/* WindowSwitcher.c generated by valac 0.43.4, the Vala compiler
 * generated from WindowSwitcher.vala, do not modify */

/**/
/*  Copyright (C) 2012 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <clutter/clutter.h>
#include <glib-object.h>
#include "gala.h"
#include <glib.h>
#include <meta/meta-window-actor.h>
#include <plank.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <meta/meta-plugin.h>
#include <meta/screen.h>
#include <meta/boxes.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <meta/display.h>
#include <gdk/gdk.h>
#include <meta/window.h>
#include <meta/keybindings.h>
#include <meta/workspace.h>
#include <stdlib.h>
#include <string.h>
#include <meta/compositor-mutter.h>
#include <granite.h>

#define GALA_TYPE_WINDOW_SWITCHER (gala_window_switcher_get_type ())
#define GALA_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher))
#define GALA_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))
#define GALA_IS_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_IS_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_WINDOW_SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))

typedef struct _GalaWindowSwitcher GalaWindowSwitcher;
typedef struct _GalaWindowSwitcherClass GalaWindowSwitcherClass;
typedef struct _GalaWindowSwitcherPrivate GalaWindowSwitcherPrivate;
enum  {
	GALA_WINDOW_SWITCHER_0_PROPERTY,
	GALA_WINDOW_SWITCHER_WM_PROPERTY,
	GALA_WINDOW_SWITCHER_NUM_PROPERTIES
};
static GParamSpec* gala_window_switcher_properties[GALA_WINDOW_SWITCHER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define GALA_TYPE_SAFE_WINDOW_CLONE (gala_safe_window_clone_get_type ())
#define GALA_SAFE_WINDOW_CLONE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowClone))
#define GALA_SAFE_WINDOW_CLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowCloneClass))
#define GALA_IS_SAFE_WINDOW_CLONE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SAFE_WINDOW_CLONE))
#define GALA_IS_SAFE_WINDOW_CLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SAFE_WINDOW_CLONE))
#define GALA_SAFE_WINDOW_CLONE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowCloneClass))

typedef struct _GalaSafeWindowClone GalaSafeWindowClone;
typedef struct _GalaSafeWindowCloneClass GalaSafeWindowCloneClass;

#define GALA_TYPE_BEHAVIOR_SETTINGS (gala_behavior_settings_get_type ())
#define GALA_BEHAVIOR_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_BEHAVIOR_SETTINGS, GalaBehaviorSettings))
#define GALA_BEHAVIOR_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_BEHAVIOR_SETTINGS, GalaBehaviorSettingsClass))
#define GALA_IS_BEHAVIOR_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_BEHAVIOR_SETTINGS))
#define GALA_IS_BEHAVIOR_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_BEHAVIOR_SETTINGS))
#define GALA_BEHAVIOR_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_BEHAVIOR_SETTINGS, GalaBehaviorSettingsClass))

typedef struct _GalaBehaviorSettings GalaBehaviorSettings;
typedef struct _GalaBehaviorSettingsClass GalaBehaviorSettingsClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block45Data Block45Data;

struct _GalaWindowSwitcher {
	ClutterActor parent_instance;
	GalaWindowSwitcherPrivate * priv;
};

struct _GalaWindowSwitcherClass {
	ClutterActorClass parent_class;
};

struct _GalaWindowSwitcherPrivate {
	GalaWindowManager* _wm;
	GalaWindowIcon* current_window;
	ClutterActor* window_clones;
	GList* clone_sort_order;
	MetaWindowActor* dock_window;
	ClutterActor* dock;
	PlankSurface* dock_surface;
	PlankDockTheme* dock_theme;
	PlankDockPreferences* dock_settings;
	gfloat dock_y_offset;
	gfloat dock_height_offset;
	gint ui_scale_factor;
	GFileMonitor* monitor;
	ClutterActor* background;
	guint modifier_mask;
	gint64 last_switch;
	gboolean closing;
	GalaModalProxy* modal_proxy;
	gfloat dock_width;
	gint n_dock_items;
};

struct _Block45Data {
	int _ref_count_;
	GalaWindowSwitcher* self;
	ClutterCanvas* dock_canvas;
};

static gint GalaWindowSwitcher_private_offset;
static gpointer gala_window_switcher_parent_class = NULL;

GType gala_window_switcher_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowSwitcher, g_object_unref)
GalaWindowManager* gala_window_switcher_get_wm (GalaWindowSwitcher* self);
static void gala_window_switcher_update_actors (GalaWindowSwitcher* self);
static void _gala_window_switcher_update_actors_meta_screen_monitors_changed (MetaScreen* _sender,
                                                                       gpointer self);
#define GALA_WINDOW_SWITCHER_MIN_DELTA 100
#define GALA_WINDOW_SWITCHER_BACKGROUND_OPACITY 155.0f
#define GALA_WINDOW_SWITCHER_DIM_WINDOW_BRIGHTNESS ((-GALA_WINDOW_SWITCHER_BACKGROUND_OPACITY) / 255.0f)
GalaWindowSwitcher* gala_window_switcher_new (GalaWindowManager* wm);
GalaWindowSwitcher* gala_window_switcher_construct (GType object_type,
                                                    GalaWindowManager* wm);
static void gala_window_switcher_load_dock_theme (GalaWindowSwitcher* self);
static void gala_window_switcher_update_dock (GalaWindowSwitcher* self);
static void _gala_window_switcher_update_dock_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static void gala_window_switcher_update_background (GalaWindowSwitcher* self);
static gboolean gala_window_switcher_draw_dock_background (GalaWindowSwitcher* self,
                                                    cairo_t* cr);
static void gala_window_switcher_place_dock (GalaWindowSwitcher* self);
gint gala_internal_utils_get_ui_scaling_factor (void);
static void gala_window_switcher_animate_dock_width (GalaWindowSwitcher* self);
static void gala_window_switcher_show_background (GalaWindowSwitcher* self);
static void gala_window_switcher_hide_background (GalaWindowSwitcher* self);
static gboolean gala_window_switcher_clicked_icon (GalaWindowSwitcher* self,
                                            ClutterButtonEvent* event);
static void gala_window_switcher_dim_windows (GalaWindowSwitcher* self);
static gboolean ___lambda42_ (GalaWindowSwitcher* self);
static void gala_window_switcher_close (GalaWindowSwitcher* self,
                                 guint time);
static gboolean ____lambda42__gsource_func (gpointer self);
static void gala_window_switcher_window_removed (GalaWindowSwitcher* self,
                                          ClutterActor* actor);
static void gala_window_switcher_icon_removed (GalaWindowSwitcher* self,
                                        ClutterActor* actor);
static gboolean gala_window_switcher_real_key_release_event (ClutterActor* base,
                                                      ClutterKeyEvent* event);
static GdkModifierType gala_window_switcher_get_current_modifiers (GalaWindowSwitcher* self);
static void gala_window_switcher_real_key_focus_out (ClutterActor* base);
void gala_window_switcher_handle_switch_windows (MetaDisplay* display,
                                                 MetaScreen* screen,
                                                 MetaWindow* window,
                                                 ClutterKeyEvent* event,
                                                 MetaKeyBinding* binding,
                                                 GalaWindowSwitcher* self);
static void gala_window_switcher_close_cleanup (GalaWindowSwitcher* self);
static GalaWindowIcon* gala_window_switcher_next_window (GalaWindowSwitcher* self,
                                                  MetaWorkspace* workspace,
                                                  gboolean backward);
static gboolean gala_window_switcher_collect_windows (GalaWindowSwitcher* self,
                                               MetaWorkspace* workspace);
static void gala_window_switcher_set_primary_modifier (GalaWindowSwitcher* self,
                                                guint mask);
static gboolean __lambda44_ (GalaWindowSwitcher* self,
                      MetaKeyBinding* binding);
static gboolean ___lambda44__gala_keybinding_filter (MetaKeyBinding* binding,
                                              gpointer self);
GType gala_safe_window_clone_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaSafeWindowClone, g_object_unref)
MetaWindow* gala_safe_window_clone_get_window (GalaSafeWindowClone* self);
static void ___lambda43_ (GalaWindowSwitcher* self);
static void ____lambda43__clutter_timeline_completed (ClutterTimeline* _sender,
                                               gpointer self);
static GalaWindowIcon* gala_window_switcher_add_window (GalaWindowSwitcher* self,
                                                 MetaWindow* window);
GalaSafeWindowClone* gala_safe_window_clone_new (MetaWindow* window,
                                                 gboolean destroy_on_unmanaged);
GalaSafeWindowClone* gala_safe_window_clone_construct (GType object_type,
                                                       MetaWindow* window,
                                                       gboolean destroy_on_unmanaged);
static gboolean _gala_window_switcher_clicked_icon_clutter_actor_button_release_event (ClutterActor* _sender,
                                                                                ClutterButtonEvent* event,
                                                                                gpointer self);
GType gala_behavior_settings_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaBehaviorSettings, g_object_unref)
GalaBehaviorSettings* gala_behavior_settings_get_default (void);
gchar** gala_behavior_settings_get_dock_names (GalaBehaviorSettings* self,
                                               gint* result_length1);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      int stack_length,
                                      const gchar* needle);
static void gala_window_switcher_update_n_dock_items (GalaWindowSwitcher* self,
                                               GFile* folder,
                                               GFile* other_file,
                                               GFileMonitorEvent event);
static void gala_window_switcher_set_wm (GalaWindowSwitcher* self,
                                  GalaWindowManager* value);
static GObject * gala_window_switcher_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static Block45Data* block45_data_ref (Block45Data* _data45_);
static void block45_data_unref (void * _userdata_);
static void _gala_window_switcher_load_dock_theme_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void _gala_window_switcher_update_n_dock_items_g_file_monitor_changed (GFileMonitor* _sender,
                                                                       GFile* file,
                                                                       GFile* other_file,
                                                                       GFileMonitorEvent event_type,
                                                                       gpointer self);
static gboolean _gala_window_switcher_draw_dock_background_clutter_canvas_draw (ClutterCanvas* _sender,
                                                                         cairo_t* cr,
                                                                         gint width,
                                                                         gint height,
                                                                         gpointer self);
static void _gala_window_switcher_icon_removed_clutter_container_actor_removed (ClutterContainer* _sender,
                                                                         ClutterActor* actor,
                                                                         gpointer self);
static void _gala_window_switcher___lambda45_ (Block45Data* _data45_);
static void __gala_window_switcher___lambda45__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void _gala_window_switcher_window_removed_clutter_container_actor_removed (ClutterContainer* _sender,
                                                                           ClutterActor* actor,
                                                                           gpointer self);
static void gala_window_switcher_finalize (GObject * obj);
static void _vala_gala_window_switcher_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_window_switcher_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
gala_window_switcher_get_instance_private (GalaWindowSwitcher* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowSwitcher_private_offset);
}

static void
_gala_window_switcher_update_actors_meta_screen_monitors_changed (MetaScreen* _sender,
                                                                  gpointer self)
{
#line 117 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_update_actors ((GalaWindowSwitcher*) self);
#line 266 "WindowSwitcher.c"
}

GalaWindowSwitcher*
gala_window_switcher_construct (GType object_type,
                                GalaWindowManager* wm)
{
	GalaWindowSwitcher * self = NULL;
#line 57 "../src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 59 "../src/Widgets/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) g_object_new (object_type, "wm", wm, NULL);
#line 57 "../src/Widgets/WindowSwitcher.vala"
	return self;
#line 280 "WindowSwitcher.c"
}

GalaWindowSwitcher*
gala_window_switcher_new (GalaWindowManager* wm)
{
#line 57 "../src/Widgets/WindowSwitcher.vala"
	return gala_window_switcher_construct (GALA_TYPE_WINDOW_SWITCHER, wm);
#line 288 "WindowSwitcher.c"
}

static void
_gala_window_switcher_update_dock_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
#line 123 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_update_dock ((GalaWindowSwitcher*) self);
#line 298 "WindowSwitcher.c"
}

static void
gala_window_switcher_load_dock_theme (GalaWindowSwitcher* self)
{
	PlankDockTheme* _tmp0_;
	PlankDockPreferences* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	PlankDockTheme* _tmp6_;
	PlankDockTheme* _tmp7_;
	PlankDockTheme* _tmp8_;
#line 120 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->dock_theme;
#line 122 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp0_ != NULL) {
#line 317 "WindowSwitcher.c"
		PlankDockTheme* _tmp1_;
		guint _tmp2_;
#line 123 "../src/Widgets/WindowSwitcher.vala"
		_tmp1_ = self->priv->dock_theme;
#line 123 "../src/Widgets/WindowSwitcher.vala"
		g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp2_, NULL, FALSE);
#line 123 "../src/Widgets/WindowSwitcher.vala"
		g_signal_handlers_disconnect_matched ((GObject*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _gala_window_switcher_update_dock_g_object_notify, self);
#line 326 "WindowSwitcher.c"
	}
#line 125 "../src/Widgets/WindowSwitcher.vala"
	_tmp3_ = self->priv->dock_settings;
#line 125 "../src/Widgets/WindowSwitcher.vala"
	_tmp4_ = plank_dock_preferences_get_Theme (_tmp3_);
#line 125 "../src/Widgets/WindowSwitcher.vala"
	_tmp5_ = _tmp4_;
#line 125 "../src/Widgets/WindowSwitcher.vala"
	_tmp6_ = plank_dock_theme_new (_tmp5_);
#line 125 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock_theme);
#line 125 "../src/Widgets/WindowSwitcher.vala"
	self->priv->dock_theme = _tmp6_;
#line 126 "../src/Widgets/WindowSwitcher.vala"
	_tmp7_ = self->priv->dock_theme;
#line 126 "../src/Widgets/WindowSwitcher.vala"
	plank_theme_load ((PlankTheme*) _tmp7_, "dock");
#line 127 "../src/Widgets/WindowSwitcher.vala"
	_tmp8_ = self->priv->dock_theme;
#line 127 "../src/Widgets/WindowSwitcher.vala"
	g_signal_connect_object ((GObject*) _tmp8_, "notify", (GCallback) _gala_window_switcher_update_dock_g_object_notify, self, 0);
#line 129 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_update_dock (self);
#line 350 "WindowSwitcher.c"
}

/**
 * set the values which don't get set every time and need to be updated when the theme changes
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 137 "../src/Widgets/WindowSwitcher.vala"
	return self ? g_object_ref (self) : NULL;
#line 361 "WindowSwitcher.c"
}

static void
gala_window_switcher_update_dock (GalaWindowSwitcher* self)
{
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	MetaRectangle geometry = {0};
	MetaScreen* _tmp3_;
	MetaScreen* _tmp4_;
	MetaRectangle _tmp5_ = {0};
	ClutterBoxLayout* layout = NULL;
	ClutterActor* _tmp6_;
	ClutterLayoutManager* _tmp7_;
	ClutterLayoutManager* _tmp8_;
	ClutterBoxLayout* _tmp9_;
	GtkPositionType position = 0;
	PlankDockPreferences* _tmp10_;
	GtkPositionType _tmp11_;
	GtkPositionType _tmp12_;
	gint icon_size = 0;
	PlankDockPreferences* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gfloat scaled_icon_size = 0.0F;
	gboolean horizontal = FALSE;
	PlankDockPreferences* _tmp16_;
	gfloat top_padding = 0.0F;
	PlankDockTheme* _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gfloat bottom_padding = 0.0F;
	PlankDockTheme* _tmp20_;
	gdouble _tmp21_;
	gdouble _tmp22_;
	gfloat item_padding = 0.0F;
	PlankDockTheme* _tmp23_;
	gdouble _tmp24_;
	gdouble _tmp25_;
	gint line_width = 0;
	PlankDockTheme* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gfloat top_offset = 0.0F;
	gint _tmp29_ = 0;
	PlankDockTheme* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	gfloat bottom_offset = 0.0F;
	ClutterBoxLayout* _tmp33_;
	ClutterOrientation _tmp34_ = 0;
	ClutterBoxLayout* _tmp35_;
	gfloat _tmp36_ = 0.0F;
	gfloat height = 0.0F;
	GtkPositionType _tmp45_;
#line 135 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 137 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 137 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 137 "../src/Widgets/WindowSwitcher.vala"
	screen = _tmp2_;
#line 138 "../src/Widgets/WindowSwitcher.vala"
	_tmp3_ = screen;
#line 138 "../src/Widgets/WindowSwitcher.vala"
	_tmp4_ = screen;
#line 138 "../src/Widgets/WindowSwitcher.vala"
	meta_screen_get_monitor_geometry (_tmp3_, meta_screen_get_primary_monitor (_tmp4_), &_tmp5_);
#line 138 "../src/Widgets/WindowSwitcher.vala"
	geometry = _tmp5_;
#line 139 "../src/Widgets/WindowSwitcher.vala"
	_tmp6_ = self->priv->dock;
#line 139 "../src/Widgets/WindowSwitcher.vala"
	_tmp7_ = clutter_actor_get_layout_manager (_tmp6_);
#line 139 "../src/Widgets/WindowSwitcher.vala"
	_tmp8_ = _tmp7_;
#line 139 "../src/Widgets/WindowSwitcher.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, clutter_box_layout_get_type (), ClutterBoxLayout));
#line 139 "../src/Widgets/WindowSwitcher.vala"
	layout = _tmp9_;
#line 141 "../src/Widgets/WindowSwitcher.vala"
	_tmp10_ = self->priv->dock_settings;
#line 141 "../src/Widgets/WindowSwitcher.vala"
	_tmp11_ = plank_dock_preferences_get_Position (_tmp10_);
#line 141 "../src/Widgets/WindowSwitcher.vala"
	_tmp12_ = _tmp11_;
#line 141 "../src/Widgets/WindowSwitcher.vala"
	position = _tmp12_;
#line 142 "../src/Widgets/WindowSwitcher.vala"
	_tmp13_ = self->priv->dock_settings;
#line 142 "../src/Widgets/WindowSwitcher.vala"
	_tmp14_ = plank_dock_preferences_get_IconSize (_tmp13_);
#line 142 "../src/Widgets/WindowSwitcher.vala"
	_tmp15_ = _tmp14_;
#line 142 "../src/Widgets/WindowSwitcher.vala"
	icon_size = _tmp15_ * self->priv->ui_scale_factor;
#line 143 "../src/Widgets/WindowSwitcher.vala"
	scaled_icon_size = icon_size / 10.0f;
#line 144 "../src/Widgets/WindowSwitcher.vala"
	_tmp16_ = self->priv->dock_settings;
#line 144 "../src/Widgets/WindowSwitcher.vala"
	horizontal = plank_dock_preferences_is_horizontal_dock (_tmp16_);
#line 146 "../src/Widgets/WindowSwitcher.vala"
	_tmp17_ = self->priv->dock_theme;
#line 146 "../src/Widgets/WindowSwitcher.vala"
	_tmp18_ = plank_dock_theme_get_TopPadding (_tmp17_);
#line 146 "../src/Widgets/WindowSwitcher.vala"
	_tmp19_ = _tmp18_;
#line 146 "../src/Widgets/WindowSwitcher.vala"
	top_padding = ((gfloat) _tmp19_) * scaled_icon_size;
#line 147 "../src/Widgets/WindowSwitcher.vala"
	_tmp20_ = self->priv->dock_theme;
#line 147 "../src/Widgets/WindowSwitcher.vala"
	_tmp21_ = plank_dock_theme_get_BottomPadding (_tmp20_);
#line 147 "../src/Widgets/WindowSwitcher.vala"
	_tmp22_ = _tmp21_;
#line 147 "../src/Widgets/WindowSwitcher.vala"
	bottom_padding = ((gfloat) _tmp22_) * scaled_icon_size;
#line 148 "../src/Widgets/WindowSwitcher.vala"
	_tmp23_ = self->priv->dock_theme;
#line 148 "../src/Widgets/WindowSwitcher.vala"
	_tmp24_ = plank_dock_theme_get_ItemPadding (_tmp23_);
#line 148 "../src/Widgets/WindowSwitcher.vala"
	_tmp25_ = _tmp24_;
#line 148 "../src/Widgets/WindowSwitcher.vala"
	item_padding = ((gfloat) _tmp25_) * scaled_icon_size;
#line 149 "../src/Widgets/WindowSwitcher.vala"
	_tmp26_ = self->priv->dock_theme;
#line 149 "../src/Widgets/WindowSwitcher.vala"
	_tmp27_ = plank_theme_get_LineWidth ((PlankTheme*) _tmp26_);
#line 149 "../src/Widgets/WindowSwitcher.vala"
	_tmp28_ = _tmp27_;
#line 149 "../src/Widgets/WindowSwitcher.vala"
	line_width = _tmp28_ * self->priv->ui_scale_factor;
#line 151 "../src/Widgets/WindowSwitcher.vala"
	top_offset = (2 * line_width) + top_padding;
#line 152 "../src/Widgets/WindowSwitcher.vala"
	_tmp30_ = self->priv->dock_theme;
#line 152 "../src/Widgets/WindowSwitcher.vala"
	_tmp31_ = plank_theme_get_BottomRoundness ((PlankTheme*) _tmp30_);
#line 152 "../src/Widgets/WindowSwitcher.vala"
	_tmp32_ = _tmp31_;
#line 152 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp32_ > 0) {
#line 152 "../src/Widgets/WindowSwitcher.vala"
		_tmp29_ = 2 * line_width;
#line 513 "WindowSwitcher.c"
	} else {
#line 152 "../src/Widgets/WindowSwitcher.vala"
		_tmp29_ = 0;
#line 517 "WindowSwitcher.c"
	}
#line 152 "../src/Widgets/WindowSwitcher.vala"
	bottom_offset = _tmp29_ + bottom_padding;
#line 154 "../src/Widgets/WindowSwitcher.vala"
	_tmp33_ = layout;
#line 154 "../src/Widgets/WindowSwitcher.vala"
	clutter_box_layout_set_spacing (_tmp33_, (guint) item_padding);
#line 155 "../src/Widgets/WindowSwitcher.vala"
	if (horizontal) {
#line 155 "../src/Widgets/WindowSwitcher.vala"
		_tmp34_ = CLUTTER_ORIENTATION_HORIZONTAL;
#line 529 "WindowSwitcher.c"
	} else {
#line 155 "../src/Widgets/WindowSwitcher.vala"
		_tmp34_ = CLUTTER_ORIENTATION_VERTICAL;
#line 533 "WindowSwitcher.c"
	}
#line 155 "../src/Widgets/WindowSwitcher.vala"
	_tmp35_ = layout;
#line 155 "../src/Widgets/WindowSwitcher.vala"
	clutter_box_layout_set_orientation (_tmp35_, _tmp34_);
#line 157 "../src/Widgets/WindowSwitcher.vala"
	self->priv->dock_y_offset = -top_offset;
#line 158 "../src/Widgets/WindowSwitcher.vala"
	self->priv->dock_height_offset = top_offset + bottom_offset;
#line 160 "../src/Widgets/WindowSwitcher.vala"
	if (top_offset > ((gfloat) 0)) {
#line 160 "../src/Widgets/WindowSwitcher.vala"
		_tmp36_ = top_offset;
#line 547 "WindowSwitcher.c"
	} else {
#line 160 "../src/Widgets/WindowSwitcher.vala"
		_tmp36_ = (gfloat) 0;
#line 551 "WindowSwitcher.c"
	}
#line 160 "../src/Widgets/WindowSwitcher.vala"
	height = (icon_size + _tmp36_) + bottom_offset;
#line 162 "../src/Widgets/WindowSwitcher.vala"
	if (horizontal) {
#line 557 "WindowSwitcher.c"
		ClutterActor* _tmp37_;
		ClutterActor* _tmp38_;
		MetaRectangle _tmp39_;
		MetaRectangle _tmp40_;
#line 163 "../src/Widgets/WindowSwitcher.vala"
		_tmp37_ = self->priv->dock;
#line 163 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_height (_tmp37_, height);
#line 164 "../src/Widgets/WindowSwitcher.vala"
		_tmp38_ = self->priv->dock;
#line 164 "../src/Widgets/WindowSwitcher.vala"
		_tmp39_ = geometry;
#line 164 "../src/Widgets/WindowSwitcher.vala"
		_tmp40_ = geometry;
#line 164 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_x (_tmp38_, ceilf (_tmp39_.x + (_tmp40_.width / 2.0f)));
#line 574 "WindowSwitcher.c"
	} else {
		ClutterActor* _tmp41_;
		ClutterActor* _tmp42_;
		MetaRectangle _tmp43_;
		MetaRectangle _tmp44_;
#line 166 "../src/Widgets/WindowSwitcher.vala"
		_tmp41_ = self->priv->dock;
#line 166 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_width (_tmp41_, height);
#line 167 "../src/Widgets/WindowSwitcher.vala"
		_tmp42_ = self->priv->dock;
#line 167 "../src/Widgets/WindowSwitcher.vala"
		_tmp43_ = geometry;
#line 167 "../src/Widgets/WindowSwitcher.vala"
		_tmp44_ = geometry;
#line 167 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_y (_tmp42_, ceilf (_tmp43_.y + (_tmp44_.height / 2.0f)));
#line 592 "WindowSwitcher.c"
	}
#line 170 "../src/Widgets/WindowSwitcher.vala"
	_tmp45_ = position;
#line 170 "../src/Widgets/WindowSwitcher.vala"
	switch (_tmp45_) {
#line 170 "../src/Widgets/WindowSwitcher.vala"
		case GTK_POS_TOP:
#line 600 "WindowSwitcher.c"
		{
			ClutterActor* _tmp46_;
			MetaRectangle _tmp47_;
#line 172 "../src/Widgets/WindowSwitcher.vala"
			_tmp46_ = self->priv->dock;
#line 172 "../src/Widgets/WindowSwitcher.vala"
			_tmp47_ = geometry;
#line 172 "../src/Widgets/WindowSwitcher.vala"
			clutter_actor_set_y (_tmp46_, ceilf ((gfloat) _tmp47_.y));
#line 173 "../src/Widgets/WindowSwitcher.vala"
			break;
#line 612 "WindowSwitcher.c"
		}
#line 170 "../src/Widgets/WindowSwitcher.vala"
		case GTK_POS_BOTTOM:
#line 616 "WindowSwitcher.c"
		{
			ClutterActor* _tmp48_;
			MetaRectangle _tmp49_;
			MetaRectangle _tmp50_;
#line 175 "../src/Widgets/WindowSwitcher.vala"
			_tmp48_ = self->priv->dock;
#line 175 "../src/Widgets/WindowSwitcher.vala"
			_tmp49_ = geometry;
#line 175 "../src/Widgets/WindowSwitcher.vala"
			_tmp50_ = geometry;
#line 175 "../src/Widgets/WindowSwitcher.vala"
			clutter_actor_set_y (_tmp48_, ceilf ((_tmp49_.y + _tmp50_.height) - height));
#line 176 "../src/Widgets/WindowSwitcher.vala"
			break;
#line 631 "WindowSwitcher.c"
		}
#line 170 "../src/Widgets/WindowSwitcher.vala"
		case GTK_POS_LEFT:
#line 635 "WindowSwitcher.c"
		{
			ClutterActor* _tmp51_;
			MetaRectangle _tmp52_;
#line 178 "../src/Widgets/WindowSwitcher.vala"
			_tmp51_ = self->priv->dock;
#line 178 "../src/Widgets/WindowSwitcher.vala"
			_tmp52_ = geometry;
#line 178 "../src/Widgets/WindowSwitcher.vala"
			clutter_actor_set_x (_tmp51_, ceilf ((gfloat) _tmp52_.x));
#line 179 "../src/Widgets/WindowSwitcher.vala"
			break;
#line 647 "WindowSwitcher.c"
		}
#line 170 "../src/Widgets/WindowSwitcher.vala"
		case GTK_POS_RIGHT:
#line 651 "WindowSwitcher.c"
		{
			ClutterActor* _tmp53_;
			MetaRectangle _tmp54_;
			MetaRectangle _tmp55_;
#line 181 "../src/Widgets/WindowSwitcher.vala"
			_tmp53_ = self->priv->dock;
#line 181 "../src/Widgets/WindowSwitcher.vala"
			_tmp54_ = geometry;
#line 181 "../src/Widgets/WindowSwitcher.vala"
			_tmp55_ = geometry;
#line 181 "../src/Widgets/WindowSwitcher.vala"
			clutter_actor_set_x (_tmp53_, ceilf ((_tmp54_.x + _tmp55_.width) - height));
#line 182 "../src/Widgets/WindowSwitcher.vala"
			break;
#line 666 "WindowSwitcher.c"
		}
		default:
#line 170 "../src/Widgets/WindowSwitcher.vala"
		break;
#line 671 "WindowSwitcher.c"
	}
#line 185 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock_surface);
#line 185 "../src/Widgets/WindowSwitcher.vala"
	self->priv->dock_surface = NULL;
#line 135 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (layout);
#line 135 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (screen);
#line 681 "WindowSwitcher.c"
}

static void
gala_window_switcher_update_background (GalaWindowSwitcher* self)
{
	gint width = 0;
	gint height = 0;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	ClutterActor* _tmp4_;
#line 188 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/Widgets/WindowSwitcher.vala"
	width = 0;
#line 190 "../src/Widgets/WindowSwitcher.vala"
	height = 0;
#line 191 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 191 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 191 "../src/Widgets/WindowSwitcher.vala"
	meta_screen_get_size (_tmp1_, &_tmp2_, &_tmp3_);
#line 191 "../src/Widgets/WindowSwitcher.vala"
	width = _tmp2_;
#line 191 "../src/Widgets/WindowSwitcher.vala"
	height = _tmp3_;
#line 193 "../src/Widgets/WindowSwitcher.vala"
	_tmp4_ = self->priv->background;
#line 193 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_size (_tmp4_, (gfloat) width, (gfloat) height);
#line 714 "WindowSwitcher.c"
}

static void
gala_window_switcher_update_actors (GalaWindowSwitcher* self)
{
#line 196 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 198 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_update_dock (self);
#line 199 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_update_background (self);
#line 726 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_draw_dock_background (GalaWindowSwitcher* self,
                                           cairo_t* cr)
{
	gboolean result = FALSE;
	GtkPositionType position = 0;
	PlankDockPreferences* _tmp0_;
	GtkPositionType _tmp1_;
	GtkPositionType _tmp2_;
	gint width = 0;
	ClutterActor* _tmp3_;
	gfloat _tmp4_;
	gfloat _tmp5_;
	gint height = 0;
	ClutterActor* _tmp6_;
	gfloat _tmp7_;
	gfloat _tmp8_;
	GtkPositionType _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	PlankSurface* _tmp12_;
	gfloat x = 0.0F;
	gfloat y = 0.0F;
	GtkPositionType _tmp25_;
	PlankSurface* _tmp26_;
	cairo_surface_t* _tmp27_;
	cairo_surface_t* _tmp28_;
#line 202 "../src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 202 "../src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 204 "../src/Widgets/WindowSwitcher.vala"
	cairo_set_operator (cr, CAIRO_OPERATOR_CLEAR);
#line 205 "../src/Widgets/WindowSwitcher.vala"
	cairo_paint (cr);
#line 206 "../src/Widgets/WindowSwitcher.vala"
	cairo_set_operator (cr, CAIRO_OPERATOR_OVER);
#line 208 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->dock_settings;
#line 208 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = plank_dock_preferences_get_Position (_tmp0_);
#line 208 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 208 "../src/Widgets/WindowSwitcher.vala"
	position = _tmp2_;
#line 210 "../src/Widgets/WindowSwitcher.vala"
	_tmp3_ = self->priv->dock;
#line 210 "../src/Widgets/WindowSwitcher.vala"
	_tmp4_ = clutter_actor_get_width (_tmp3_);
#line 210 "../src/Widgets/WindowSwitcher.vala"
	_tmp5_ = _tmp4_;
#line 210 "../src/Widgets/WindowSwitcher.vala"
	width = (gint) _tmp5_;
#line 211 "../src/Widgets/WindowSwitcher.vala"
	_tmp6_ = self->priv->dock;
#line 211 "../src/Widgets/WindowSwitcher.vala"
	_tmp7_ = clutter_actor_get_height (_tmp6_);
#line 211 "../src/Widgets/WindowSwitcher.vala"
	_tmp8_ = _tmp7_;
#line 211 "../src/Widgets/WindowSwitcher.vala"
	height = (gint) _tmp8_;
#line 213 "../src/Widgets/WindowSwitcher.vala"
	_tmp9_ = position;
#line 213 "../src/Widgets/WindowSwitcher.vala"
	switch (_tmp9_) {
#line 213 "../src/Widgets/WindowSwitcher.vala"
		case GTK_POS_RIGHT:
#line 796 "WindowSwitcher.c"
		{
#line 215 "../src/Widgets/WindowSwitcher.vala"
			width += (gint) self->priv->dock_height_offset;
#line 216 "../src/Widgets/WindowSwitcher.vala"
			break;
#line 802 "WindowSwitcher.c"
		}
#line 213 "../src/Widgets/WindowSwitcher.vala"
		case GTK_POS_LEFT:
#line 806 "WindowSwitcher.c"
		{
#line 218 "../src/Widgets/WindowSwitcher.vala"
			width -= (gint) self->priv->dock_y_offset;
#line 219 "../src/Widgets/WindowSwitcher.vala"
			break;
#line 812 "WindowSwitcher.c"
		}
#line 213 "../src/Widgets/WindowSwitcher.vala"
		case GTK_POS_TOP:
#line 816 "WindowSwitcher.c"
		{
#line 221 "../src/Widgets/WindowSwitcher.vala"
			height -= (gint) self->priv->dock_y_offset;
#line 222 "../src/Widgets/WindowSwitcher.vala"
			break;
#line 822 "WindowSwitcher.c"
		}
#line 213 "../src/Widgets/WindowSwitcher.vala"
		case GTK_POS_BOTTOM:
#line 826 "WindowSwitcher.c"
		{
#line 224 "../src/Widgets/WindowSwitcher.vala"
			height += (gint) self->priv->dock_height_offset;
#line 225 "../src/Widgets/WindowSwitcher.vala"
			break;
#line 832 "WindowSwitcher.c"
		}
		default:
#line 213 "../src/Widgets/WindowSwitcher.vala"
		break;
#line 837 "WindowSwitcher.c"
	}
#line 228 "../src/Widgets/WindowSwitcher.vala"
	_tmp12_ = self->priv->dock_surface;
#line 228 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp12_ == NULL) {
#line 228 "../src/Widgets/WindowSwitcher.vala"
		_tmp11_ = TRUE;
#line 845 "WindowSwitcher.c"
	} else {
		PlankSurface* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 228 "../src/Widgets/WindowSwitcher.vala"
		_tmp13_ = self->priv->dock_surface;
#line 228 "../src/Widgets/WindowSwitcher.vala"
		_tmp14_ = plank_surface_get_Width (_tmp13_);
#line 228 "../src/Widgets/WindowSwitcher.vala"
		_tmp15_ = _tmp14_;
#line 228 "../src/Widgets/WindowSwitcher.vala"
		_tmp11_ = _tmp15_ != width;
#line 858 "WindowSwitcher.c"
	}
#line 228 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp11_) {
#line 228 "../src/Widgets/WindowSwitcher.vala"
		_tmp10_ = TRUE;
#line 864 "WindowSwitcher.c"
	} else {
		PlankSurface* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
#line 228 "../src/Widgets/WindowSwitcher.vala"
		_tmp16_ = self->priv->dock_surface;
#line 228 "../src/Widgets/WindowSwitcher.vala"
		_tmp17_ = plank_surface_get_Height (_tmp16_);
#line 228 "../src/Widgets/WindowSwitcher.vala"
		_tmp18_ = _tmp17_;
#line 228 "../src/Widgets/WindowSwitcher.vala"
		_tmp10_ = _tmp18_ != height;
#line 877 "WindowSwitcher.c"
	}
#line 228 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp10_) {
#line 881 "WindowSwitcher.c"
		PlankSurface* dummy_surface = NULL;
		cairo_surface_t* _tmp19_;
		PlankSurface* _tmp20_;
		PlankDockTheme* _tmp21_;
		GtkPositionType _tmp22_;
		PlankSurface* _tmp23_;
		PlankSurface* _tmp24_;
#line 229 "../src/Widgets/WindowSwitcher.vala"
		_tmp19_ = cairo_get_target (cr);
#line 229 "../src/Widgets/WindowSwitcher.vala"
		_tmp20_ = plank_surface_new_with_cairo_surface (1, 1, _tmp19_);
#line 229 "../src/Widgets/WindowSwitcher.vala"
		dummy_surface = _tmp20_;
#line 231 "../src/Widgets/WindowSwitcher.vala"
		_tmp21_ = self->priv->dock_theme;
#line 231 "../src/Widgets/WindowSwitcher.vala"
		_tmp22_ = position;
#line 231 "../src/Widgets/WindowSwitcher.vala"
		_tmp23_ = dummy_surface;
#line 231 "../src/Widgets/WindowSwitcher.vala"
		_tmp24_ = plank_dock_theme_create_background (_tmp21_, width / self->priv->ui_scale_factor, height / self->priv->ui_scale_factor, _tmp22_, _tmp23_);
#line 231 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->dock_surface);
#line 231 "../src/Widgets/WindowSwitcher.vala"
		self->priv->dock_surface = _tmp24_;
#line 228 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (dummy_surface);
#line 909 "WindowSwitcher.c"
	}
#line 234 "../src/Widgets/WindowSwitcher.vala"
	x = (gfloat) 0;
#line 234 "../src/Widgets/WindowSwitcher.vala"
	y = (gfloat) 0;
#line 235 "../src/Widgets/WindowSwitcher.vala"
	_tmp25_ = position;
#line 235 "../src/Widgets/WindowSwitcher.vala"
	switch (_tmp25_) {
#line 235 "../src/Widgets/WindowSwitcher.vala"
		case GTK_POS_RIGHT:
#line 921 "WindowSwitcher.c"
		{
#line 237 "../src/Widgets/WindowSwitcher.vala"
			x = self->priv->dock_y_offset;
#line 238 "../src/Widgets/WindowSwitcher.vala"
			break;
#line 927 "WindowSwitcher.c"
		}
#line 235 "../src/Widgets/WindowSwitcher.vala"
		case GTK_POS_BOTTOM:
#line 931 "WindowSwitcher.c"
		{
#line 240 "../src/Widgets/WindowSwitcher.vala"
			y = self->priv->dock_y_offset / self->priv->ui_scale_factor;
#line 241 "../src/Widgets/WindowSwitcher.vala"
			break;
#line 937 "WindowSwitcher.c"
		}
#line 235 "../src/Widgets/WindowSwitcher.vala"
		case GTK_POS_LEFT:
#line 941 "WindowSwitcher.c"
		{
#line 243 "../src/Widgets/WindowSwitcher.vala"
			x = (gfloat) 0;
#line 244 "../src/Widgets/WindowSwitcher.vala"
			break;
#line 947 "WindowSwitcher.c"
		}
#line 235 "../src/Widgets/WindowSwitcher.vala"
		case GTK_POS_TOP:
#line 951 "WindowSwitcher.c"
		{
#line 246 "../src/Widgets/WindowSwitcher.vala"
			y = (gfloat) 0;
#line 247 "../src/Widgets/WindowSwitcher.vala"
			break;
#line 957 "WindowSwitcher.c"
		}
		default:
#line 235 "../src/Widgets/WindowSwitcher.vala"
		break;
#line 962 "WindowSwitcher.c"
	}
#line 250 "../src/Widgets/WindowSwitcher.vala"
	cairo_save (cr);
#line 251 "../src/Widgets/WindowSwitcher.vala"
	cairo_scale (cr, (gdouble) self->priv->ui_scale_factor, (gdouble) self->priv->ui_scale_factor);
#line 252 "../src/Widgets/WindowSwitcher.vala"
	_tmp26_ = self->priv->dock_surface;
#line 252 "../src/Widgets/WindowSwitcher.vala"
	_tmp27_ = plank_surface_get_Internal (_tmp26_);
#line 252 "../src/Widgets/WindowSwitcher.vala"
	_tmp28_ = _tmp27_;
#line 252 "../src/Widgets/WindowSwitcher.vala"
	cairo_set_source_surface (cr, _tmp28_, (gdouble) x, (gdouble) y);
#line 253 "../src/Widgets/WindowSwitcher.vala"
	cairo_paint (cr);
#line 254 "../src/Widgets/WindowSwitcher.vala"
	cairo_restore (cr);
#line 256 "../src/Widgets/WindowSwitcher.vala"
	result = FALSE;
#line 256 "../src/Widgets/WindowSwitcher.vala"
	return result;
#line 984 "WindowSwitcher.c"
}

static void
gala_window_switcher_place_dock (GalaWindowSwitcher* self)
{
	gint icon_size = 0;
	PlankDockPreferences* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gfloat scaled_icon_size = 0.0F;
	gint line_width = 0;
	PlankDockTheme* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gdouble horiz_padding = 0.0;
	PlankDockTheme* _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gfloat item_padding = 0.0F;
	PlankDockTheme* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_ = 0.0;
	gint items_offset = 0;
	PlankDockPreferences* _tmp18_;
	ClutterActor* _tmp31_;
#line 259 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 261 "../src/Widgets/WindowSwitcher.vala"
	self->priv->ui_scale_factor = gala_internal_utils_get_ui_scaling_factor ();
#line 263 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->dock_settings;
#line 263 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = plank_dock_preferences_get_IconSize (_tmp0_);
#line 263 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 263 "../src/Widgets/WindowSwitcher.vala"
	icon_size = _tmp2_ * self->priv->ui_scale_factor;
#line 264 "../src/Widgets/WindowSwitcher.vala"
	scaled_icon_size = icon_size / 10.0f;
#line 265 "../src/Widgets/WindowSwitcher.vala"
	_tmp3_ = self->priv->dock_theme;
#line 265 "../src/Widgets/WindowSwitcher.vala"
	_tmp4_ = plank_theme_get_LineWidth ((PlankTheme*) _tmp3_);
#line 265 "../src/Widgets/WindowSwitcher.vala"
	_tmp5_ = _tmp4_;
#line 265 "../src/Widgets/WindowSwitcher.vala"
	line_width = _tmp5_ * self->priv->ui_scale_factor;
#line 266 "../src/Widgets/WindowSwitcher.vala"
	_tmp6_ = self->priv->dock_theme;
#line 266 "../src/Widgets/WindowSwitcher.vala"
	_tmp7_ = plank_dock_theme_get_HorizPadding (_tmp6_);
#line 266 "../src/Widgets/WindowSwitcher.vala"
	_tmp8_ = _tmp7_;
#line 266 "../src/Widgets/WindowSwitcher.vala"
	horiz_padding = _tmp8_ * scaled_icon_size;
#line 267 "../src/Widgets/WindowSwitcher.vala"
	_tmp9_ = self->priv->dock_theme;
#line 267 "../src/Widgets/WindowSwitcher.vala"
	_tmp10_ = plank_dock_theme_get_ItemPadding (_tmp9_);
#line 267 "../src/Widgets/WindowSwitcher.vala"
	_tmp11_ = _tmp10_;
#line 267 "../src/Widgets/WindowSwitcher.vala"
	item_padding = ((gfloat) _tmp11_) * scaled_icon_size;
#line 268 "../src/Widgets/WindowSwitcher.vala"
	if (horiz_padding > ((gdouble) 0)) {
#line 268 "../src/Widgets/WindowSwitcher.vala"
		_tmp12_ = horiz_padding;
#line 1053 "WindowSwitcher.c"
	} else {
#line 268 "../src/Widgets/WindowSwitcher.vala"
		_tmp12_ = (gdouble) 0;
#line 1057 "WindowSwitcher.c"
	}
#line 268 "../src/Widgets/WindowSwitcher.vala"
	items_offset = (gint) ((2 * line_width) + _tmp12_);
#line 270 "../src/Widgets/WindowSwitcher.vala"
	if (self->priv->n_dock_items > 0) {
#line 271 "../src/Widgets/WindowSwitcher.vala"
		self->priv->dock_width = (self->priv->n_dock_items * (item_padding + icon_size)) + (items_offset * 2);
#line 1065 "WindowSwitcher.c"
	} else {
		gfloat _tmp13_ = 0.0F;
		MetaWindowActor* _tmp14_;
#line 273 "../src/Widgets/WindowSwitcher.vala"
		_tmp14_ = self->priv->dock_window;
#line 273 "../src/Widgets/WindowSwitcher.vala"
		if (_tmp14_ != NULL) {
#line 1073 "WindowSwitcher.c"
			MetaWindowActor* _tmp15_;
			gfloat _tmp16_;
			gfloat _tmp17_;
#line 273 "../src/Widgets/WindowSwitcher.vala"
			_tmp15_ = self->priv->dock_window;
#line 273 "../src/Widgets/WindowSwitcher.vala"
			_tmp16_ = clutter_actor_get_width ((ClutterActor*) _tmp15_);
#line 273 "../src/Widgets/WindowSwitcher.vala"
			_tmp17_ = _tmp16_;
#line 273 "../src/Widgets/WindowSwitcher.vala"
			_tmp13_ = _tmp17_;
#line 1085 "WindowSwitcher.c"
		} else {
#line 273 "../src/Widgets/WindowSwitcher.vala"
			_tmp13_ = 300.0f;
#line 1089 "WindowSwitcher.c"
		}
#line 273 "../src/Widgets/WindowSwitcher.vala"
		self->priv->dock_width = _tmp13_;
#line 1093 "WindowSwitcher.c"
	}
#line 275 "../src/Widgets/WindowSwitcher.vala"
	_tmp18_ = self->priv->dock_settings;
#line 275 "../src/Widgets/WindowSwitcher.vala"
	if (plank_dock_preferences_is_horizontal_dock (_tmp18_)) {
#line 1099 "WindowSwitcher.c"
		ClutterActor* _tmp19_;
		ClutterActor* _tmp20_;
		ClutterActor* _tmp21_;
		ClutterActor* _tmp22_;
		ClutterActor* _tmp23_;
		ClutterActor* _tmp24_;
#line 276 "../src/Widgets/WindowSwitcher.vala"
		_tmp19_ = self->priv->dock;
#line 276 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_width (_tmp19_, self->priv->dock_width);
#line 277 "../src/Widgets/WindowSwitcher.vala"
		_tmp20_ = self->priv->dock;
#line 277 "../src/Widgets/WindowSwitcher.vala"
		g_object_set (_tmp20_, "translation-x", ceilf ((-self->priv->dock_width) / 2.0f), NULL);
#line 278 "../src/Widgets/WindowSwitcher.vala"
		_tmp21_ = self->priv->dock;
#line 278 "../src/Widgets/WindowSwitcher.vala"
		_tmp22_ = clutter_actor_get_first_child (_tmp21_);
#line 278 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_margin_left (_tmp22_, (gfloat) items_offset);
#line 279 "../src/Widgets/WindowSwitcher.vala"
		_tmp23_ = self->priv->dock;
#line 279 "../src/Widgets/WindowSwitcher.vala"
		_tmp24_ = clutter_actor_get_last_child (_tmp23_);
#line 279 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_margin_right (_tmp24_, (gfloat) items_offset);
#line 1126 "WindowSwitcher.c"
	} else {
		ClutterActor* _tmp25_;
		ClutterActor* _tmp26_;
		ClutterActor* _tmp27_;
		ClutterActor* _tmp28_;
		ClutterActor* _tmp29_;
		ClutterActor* _tmp30_;
#line 281 "../src/Widgets/WindowSwitcher.vala"
		_tmp25_ = self->priv->dock;
#line 281 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_height (_tmp25_, self->priv->dock_width);
#line 282 "../src/Widgets/WindowSwitcher.vala"
		_tmp26_ = self->priv->dock;
#line 282 "../src/Widgets/WindowSwitcher.vala"
		g_object_set (_tmp26_, "translation-y", ceilf ((-self->priv->dock_width) / 2.0f), NULL);
#line 283 "../src/Widgets/WindowSwitcher.vala"
		_tmp27_ = self->priv->dock;
#line 283 "../src/Widgets/WindowSwitcher.vala"
		_tmp28_ = clutter_actor_get_first_child (_tmp27_);
#line 283 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_margin_top (_tmp28_, (gfloat) items_offset);
#line 284 "../src/Widgets/WindowSwitcher.vala"
		_tmp29_ = self->priv->dock;
#line 284 "../src/Widgets/WindowSwitcher.vala"
		_tmp30_ = clutter_actor_get_last_child (_tmp29_);
#line 284 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_margin_bottom (_tmp30_, (gfloat) items_offset);
#line 1154 "WindowSwitcher.c"
	}
#line 287 "../src/Widgets/WindowSwitcher.vala"
	_tmp31_ = self->priv->dock;
#line 287 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_opacity (_tmp31_, (guint) 255);
#line 1160 "WindowSwitcher.c"
}

static void
gala_window_switcher_animate_dock_width (GalaWindowSwitcher* self)
{
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
	gfloat dest_width = 0.0F;
	PlankDockPreferences* _tmp3_;
	ClutterActor* _tmp24_;
#line 290 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 292 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->dock;
#line 292 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_save_easing_state (_tmp0_);
#line 293 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = self->priv->dock;
#line 293 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_easing_duration (_tmp1_, (guint) 250);
#line 294 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = self->priv->dock;
#line 294 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_easing_mode (_tmp2_, CLUTTER_EASE_OUT_CUBIC);
#line 297 "../src/Widgets/WindowSwitcher.vala"
	_tmp3_ = self->priv->dock_settings;
#line 297 "../src/Widgets/WindowSwitcher.vala"
	if (plank_dock_preferences_is_horizontal_dock (_tmp3_)) {
#line 1190 "WindowSwitcher.c"
		ClutterActor* _tmp4_;
		ClutterLayoutManager* _tmp5_;
		ClutterLayoutManager* _tmp6_;
		ClutterActor* _tmp7_;
		ClutterActor* _tmp8_;
		gfloat _tmp9_;
		gfloat _tmp10_;
		gfloat _tmp11_ = 0.0F;
		ClutterActor* _tmp12_;
		ClutterActor* _tmp13_;
#line 298 "../src/Widgets/WindowSwitcher.vala"
		_tmp4_ = self->priv->dock;
#line 298 "../src/Widgets/WindowSwitcher.vala"
		_tmp5_ = clutter_actor_get_layout_manager (_tmp4_);
#line 298 "../src/Widgets/WindowSwitcher.vala"
		_tmp6_ = _tmp5_;
#line 298 "../src/Widgets/WindowSwitcher.vala"
		_tmp7_ = self->priv->dock;
#line 298 "../src/Widgets/WindowSwitcher.vala"
		_tmp8_ = self->priv->dock;
#line 298 "../src/Widgets/WindowSwitcher.vala"
		_tmp9_ = clutter_actor_get_height (_tmp8_);
#line 298 "../src/Widgets/WindowSwitcher.vala"
		_tmp10_ = _tmp9_;
#line 298 "../src/Widgets/WindowSwitcher.vala"
		clutter_layout_manager_get_preferred_width (_tmp6_, (ClutterContainer*) _tmp7_, _tmp10_, NULL, &_tmp11_);
#line 298 "../src/Widgets/WindowSwitcher.vala"
		dest_width = _tmp11_;
#line 299 "../src/Widgets/WindowSwitcher.vala"
		_tmp12_ = self->priv->dock;
#line 299 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_width (_tmp12_, dest_width);
#line 300 "../src/Widgets/WindowSwitcher.vala"
		_tmp13_ = self->priv->dock;
#line 300 "../src/Widgets/WindowSwitcher.vala"
		g_object_set (_tmp13_, "translation-x", ceilf ((-dest_width) / 2.0f), NULL);
#line 1227 "WindowSwitcher.c"
	} else {
		ClutterActor* _tmp14_;
		ClutterLayoutManager* _tmp15_;
		ClutterLayoutManager* _tmp16_;
		ClutterActor* _tmp17_;
		ClutterActor* _tmp18_;
		gfloat _tmp19_;
		gfloat _tmp20_;
		gfloat _tmp21_ = 0.0F;
		ClutterActor* _tmp22_;
		ClutterActor* _tmp23_;
#line 302 "../src/Widgets/WindowSwitcher.vala"
		_tmp14_ = self->priv->dock;
#line 302 "../src/Widgets/WindowSwitcher.vala"
		_tmp15_ = clutter_actor_get_layout_manager (_tmp14_);
#line 302 "../src/Widgets/WindowSwitcher.vala"
		_tmp16_ = _tmp15_;
#line 302 "../src/Widgets/WindowSwitcher.vala"
		_tmp17_ = self->priv->dock;
#line 302 "../src/Widgets/WindowSwitcher.vala"
		_tmp18_ = self->priv->dock;
#line 302 "../src/Widgets/WindowSwitcher.vala"
		_tmp19_ = clutter_actor_get_width (_tmp18_);
#line 302 "../src/Widgets/WindowSwitcher.vala"
		_tmp20_ = _tmp19_;
#line 302 "../src/Widgets/WindowSwitcher.vala"
		clutter_layout_manager_get_preferred_height (_tmp16_, (ClutterContainer*) _tmp17_, _tmp20_, NULL, &_tmp21_);
#line 302 "../src/Widgets/WindowSwitcher.vala"
		dest_width = _tmp21_;
#line 303 "../src/Widgets/WindowSwitcher.vala"
		_tmp22_ = self->priv->dock;
#line 303 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_height (_tmp22_, dest_width);
#line 304 "../src/Widgets/WindowSwitcher.vala"
		_tmp23_ = self->priv->dock;
#line 304 "../src/Widgets/WindowSwitcher.vala"
		g_object_set (_tmp23_, "translation-y", ceilf ((-dest_width) / 2.0f), NULL);
#line 1265 "WindowSwitcher.c"
	}
#line 307 "../src/Widgets/WindowSwitcher.vala"
	_tmp24_ = self->priv->dock;
#line 307 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_restore_easing_state (_tmp24_);
#line 1271 "WindowSwitcher.c"
}

static void
gala_window_switcher_show_background (GalaWindowSwitcher* self)
{
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
	ClutterActor* _tmp3_;
	ClutterActor* _tmp4_;
#line 310 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 312 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->background;
#line 312 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_save_easing_state (_tmp0_);
#line 313 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = self->priv->background;
#line 313 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_easing_duration (_tmp1_, (guint) 250);
#line 314 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = self->priv->background;
#line 314 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_easing_mode (_tmp2_, CLUTTER_EASE_OUT_CUBIC);
#line 315 "../src/Widgets/WindowSwitcher.vala"
	_tmp3_ = self->priv->background;
#line 315 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_opacity (_tmp3_, (guint) GALA_WINDOW_SWITCHER_BACKGROUND_OPACITY);
#line 316 "../src/Widgets/WindowSwitcher.vala"
	_tmp4_ = self->priv->background;
#line 316 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_restore_easing_state (_tmp4_);
#line 1304 "WindowSwitcher.c"
}

static void
gala_window_switcher_hide_background (GalaWindowSwitcher* self)
{
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
	ClutterActor* _tmp3_;
	ClutterActor* _tmp4_;
#line 319 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->background;
#line 321 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_save_easing_state (_tmp0_);
#line 322 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = self->priv->background;
#line 322 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_easing_duration (_tmp1_, (guint) 250);
#line 323 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = self->priv->background;
#line 323 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_easing_mode (_tmp2_, CLUTTER_EASE_OUT_CUBIC);
#line 324 "../src/Widgets/WindowSwitcher.vala"
	_tmp3_ = self->priv->background;
#line 324 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_opacity (_tmp3_, (guint) 0);
#line 325 "../src/Widgets/WindowSwitcher.vala"
	_tmp4_ = self->priv->background;
#line 325 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_restore_easing_state (_tmp4_);
#line 1337 "WindowSwitcher.c"
}

static gboolean
___lambda42_ (GalaWindowSwitcher* self)
{
	gboolean result = FALSE;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaDisplay* _tmp2_;
#line 337 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 337 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 337 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = meta_screen_get_display (_tmp1_);
#line 337 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_close (self, (guint) meta_display_get_current_time (_tmp2_));
#line 338 "../src/Widgets/WindowSwitcher.vala"
	result = FALSE;
#line 338 "../src/Widgets/WindowSwitcher.vala"
	return result;
#line 1359 "WindowSwitcher.c"
}

static gboolean
____lambda42__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda42_ ((GalaWindowSwitcher*) self);
#line 336 "../src/Widgets/WindowSwitcher.vala"
	return result;
#line 1369 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_clicked_icon (GalaWindowSwitcher* self,
                                   ClutterButtonEvent* event)
{
	gboolean result = FALSE;
	GalaWindowIcon* icon = NULL;
	ClutterActor* _tmp0_;
	GalaWindowIcon* _tmp1_;
	GalaWindowIcon* _tmp2_;
#line 328 "../src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 328 "../src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 329 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = event->source;
#line 329 "../src/Widgets/WindowSwitcher.vala"
	icon = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
#line 331 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = self->priv->current_window;
#line 331 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = icon;
#line 331 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp1_ != _tmp2_) {
#line 1395 "WindowSwitcher.c"
		GalaWindowIcon* _tmp3_;
		GalaWindowIcon* _tmp4_;
#line 332 "../src/Widgets/WindowSwitcher.vala"
		_tmp3_ = icon;
#line 332 "../src/Widgets/WindowSwitcher.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 332 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->current_window);
#line 332 "../src/Widgets/WindowSwitcher.vala"
		self->priv->current_window = _tmp4_;
#line 333 "../src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_dim_windows (self);
#line 336 "../src/Widgets/WindowSwitcher.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 250, ____lambda42__gsource_func, g_object_ref (self), g_object_unref);
#line 1410 "WindowSwitcher.c"
	} else {
#line 341 "../src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_close (self, (guint) event->time);
#line 1414 "WindowSwitcher.c"
	}
#line 343 "../src/Widgets/WindowSwitcher.vala"
	result = TRUE;
#line 343 "../src/Widgets/WindowSwitcher.vala"
	return result;
#line 1420 "WindowSwitcher.c"
}

static void
gala_window_switcher_window_removed (GalaWindowSwitcher* self,
                                     ClutterActor* actor)
{
#line 346 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 346 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (actor != NULL);
#line 348 "../src/Widgets/WindowSwitcher.vala"
	self->priv->clone_sort_order = g_list_remove (self->priv->clone_sort_order, actor);
#line 1433 "WindowSwitcher.c"
}

static void
gala_window_switcher_icon_removed (GalaWindowSwitcher* self,
                                   ClutterActor* actor)
{
	ClutterActor* _tmp0_;
	GalaWindowIcon* _tmp4_;
#line 351 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 351 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (actor != NULL);
#line 353 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->dock;
#line 353 "../src/Widgets/WindowSwitcher.vala"
	if (clutter_actor_get_n_children (_tmp0_) == 1) {
#line 1450 "WindowSwitcher.c"
		GalaWindowManager* _tmp1_;
		MetaScreen* _tmp2_;
		MetaDisplay* _tmp3_;
#line 354 "../src/Widgets/WindowSwitcher.vala"
		_tmp1_ = self->priv->_wm;
#line 354 "../src/Widgets/WindowSwitcher.vala"
		_tmp2_ = meta_plugin_get_screen ((MetaPlugin*) _tmp1_);
#line 354 "../src/Widgets/WindowSwitcher.vala"
		_tmp3_ = meta_screen_get_display (_tmp2_);
#line 354 "../src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_close (self, (guint) meta_display_get_current_time (_tmp3_));
#line 355 "../src/Widgets/WindowSwitcher.vala"
		return;
#line 1464 "WindowSwitcher.c"
	}
#line 358 "../src/Widgets/WindowSwitcher.vala"
	_tmp4_ = self->priv->current_window;
#line 358 "../src/Widgets/WindowSwitcher.vala"
	if (actor == G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, clutter_actor_get_type (), ClutterActor)) {
#line 1470 "WindowSwitcher.c"
		GalaWindowIcon* _tmp5_;
		ClutterActor* _tmp6_;
		GalaWindowIcon* _tmp7_;
		GalaWindowIcon* _tmp8_;
#line 359 "../src/Widgets/WindowSwitcher.vala"
		_tmp5_ = self->priv->current_window;
#line 359 "../src/Widgets/WindowSwitcher.vala"
		_tmp6_ = clutter_actor_get_next_sibling ((ClutterActor*) _tmp5_);
#line 359 "../src/Widgets/WindowSwitcher.vala"
		_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon));
#line 359 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->current_window);
#line 359 "../src/Widgets/WindowSwitcher.vala"
		self->priv->current_window = _tmp7_;
#line 360 "../src/Widgets/WindowSwitcher.vala"
		_tmp8_ = self->priv->current_window;
#line 360 "../src/Widgets/WindowSwitcher.vala"
		if (_tmp8_ == NULL) {
#line 1489 "WindowSwitcher.c"
			ClutterActor* _tmp9_;
			ClutterActor* _tmp10_;
			GalaWindowIcon* _tmp11_;
#line 361 "../src/Widgets/WindowSwitcher.vala"
			_tmp9_ = self->priv->dock;
#line 361 "../src/Widgets/WindowSwitcher.vala"
			_tmp10_ = clutter_actor_get_first_child (_tmp9_);
#line 361 "../src/Widgets/WindowSwitcher.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon));
#line 361 "../src/Widgets/WindowSwitcher.vala"
			_g_object_unref0 (self->priv->current_window);
#line 361 "../src/Widgets/WindowSwitcher.vala"
			self->priv->current_window = _tmp11_;
#line 1503 "WindowSwitcher.c"
		}
#line 363 "../src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_dim_windows (self);
#line 1507 "WindowSwitcher.c"
	}
#line 366 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_animate_dock_width (self);
#line 1511 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_real_key_release_event (ClutterActor* base,
                                             ClutterKeyEvent* event)
{
	GalaWindowSwitcher * self;
	gboolean result = FALSE;
#line 369 "../src/Widgets/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 369 "../src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 371 "../src/Widgets/WindowSwitcher.vala"
	if ((gala_window_switcher_get_current_modifiers (self) & self->priv->modifier_mask) == 0) {
#line 372 "../src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_close (self, (guint) event->time);
#line 1528 "WindowSwitcher.c"
	}
#line 374 "../src/Widgets/WindowSwitcher.vala"
	result = TRUE;
#line 374 "../src/Widgets/WindowSwitcher.vala"
	return result;
#line 1534 "WindowSwitcher.c"
}

static void
gala_window_switcher_real_key_focus_out (ClutterActor* base)
{
	GalaWindowSwitcher * self;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaDisplay* _tmp2_;
#line 377 "../src/Widgets/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 379 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 379 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 379 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = meta_screen_get_display (_tmp1_);
#line 379 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_close (self, (guint) meta_display_get_current_time (_tmp2_));
#line 1554 "WindowSwitcher.c"
}

static gboolean
__lambda44_ (GalaWindowSwitcher* self,
             MetaKeyBinding* binding)
{
	gboolean result = FALSE;
	gchar* name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
#line 425 "../src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (binding != NULL, FALSE);
#line 427 "../src/Widgets/WindowSwitcher.vala"
	if (!meta_key_binding_is_builtin (binding)) {
#line 428 "../src/Widgets/WindowSwitcher.vala"
		result = TRUE;
#line 428 "../src/Widgets/WindowSwitcher.vala"
		return result;
#line 1577 "WindowSwitcher.c"
	}
#line 431 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = meta_key_binding_get_name (binding);
#line 431 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 431 "../src/Widgets/WindowSwitcher.vala"
	name = _tmp1_;
#line 433 "../src/Widgets/WindowSwitcher.vala"
	_tmp5_ = name;
#line 433 "../src/Widgets/WindowSwitcher.vala"
	if (g_strcmp0 (_tmp5_, "switch-applications") == 0) {
#line 433 "../src/Widgets/WindowSwitcher.vala"
		_tmp4_ = TRUE;
#line 1591 "WindowSwitcher.c"
	} else {
		const gchar* _tmp6_;
#line 433 "../src/Widgets/WindowSwitcher.vala"
		_tmp6_ = name;
#line 433 "../src/Widgets/WindowSwitcher.vala"
		_tmp4_ = g_strcmp0 (_tmp6_, "switch-applications-backward") == 0;
#line 1598 "WindowSwitcher.c"
	}
#line 433 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp4_) {
#line 433 "../src/Widgets/WindowSwitcher.vala"
		_tmp3_ = TRUE;
#line 1604 "WindowSwitcher.c"
	} else {
		const gchar* _tmp7_;
#line 434 "../src/Widgets/WindowSwitcher.vala"
		_tmp7_ = name;
#line 434 "../src/Widgets/WindowSwitcher.vala"
		_tmp3_ = g_strcmp0 (_tmp7_, "switch-windows") == 0;
#line 1611 "WindowSwitcher.c"
	}
#line 433 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp3_) {
#line 433 "../src/Widgets/WindowSwitcher.vala"
		_tmp2_ = TRUE;
#line 1617 "WindowSwitcher.c"
	} else {
		const gchar* _tmp8_;
#line 434 "../src/Widgets/WindowSwitcher.vala"
		_tmp8_ = name;
#line 434 "../src/Widgets/WindowSwitcher.vala"
		_tmp2_ = g_strcmp0 (_tmp8_, "switch-windows-backward") == 0;
#line 1624 "WindowSwitcher.c"
	}
#line 433 "../src/Widgets/WindowSwitcher.vala"
	result = !_tmp2_;
#line 433 "../src/Widgets/WindowSwitcher.vala"
	_g_free0 (name);
#line 433 "../src/Widgets/WindowSwitcher.vala"
	return result;
#line 1632 "WindowSwitcher.c"
}

static gboolean
___lambda44__gala_keybinding_filter (MetaKeyBinding* binding,
                                     gpointer self)
{
	gboolean result;
	result = __lambda44_ ((GalaWindowSwitcher*) self, binding);
#line 425 "../src/Widgets/WindowSwitcher.vala"
	return result;
#line 1643 "WindowSwitcher.c"
}

void
gala_window_switcher_handle_switch_windows (MetaDisplay* display,
                                            MetaScreen* screen,
                                            MetaWindow* window,
                                            ClutterKeyEvent* event,
                                            MetaKeyBinding* binding,
                                            GalaWindowSwitcher* self)
{
	gint64 now = 0LL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	MetaWorkspace* workspace = NULL;
	MetaWorkspace* _tmp3_;
	MetaWorkspace* _tmp4_;
	gchar* binding_name = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean backward = FALSE;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_;
	gboolean _tmp11_;
	MetaWorkspace* _tmp14_;
	MetaWorkspace* _tmp15_;
	GalaWindowIcon* _tmp16_;
	GalaWindowManager* _tmp17_;
	GalaModalProxy* _tmp18_;
	GalaModalProxy* _tmp19_;
#line 383 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 383 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (display != NULL);
#line 383 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (screen != NULL);
#line 383 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (event != NULL);
#line 383 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (binding != NULL);
#line 386 "../src/Widgets/WindowSwitcher.vala"
	now = g_get_monotonic_time () / 1000;
#line 387 "../src/Widgets/WindowSwitcher.vala"
	if ((now - self->priv->last_switch) < ((gint64) GALA_WINDOW_SWITCHER_MIN_DELTA)) {
#line 388 "../src/Widgets/WindowSwitcher.vala"
		return;
#line 1692 "WindowSwitcher.c"
	}
#line 392 "../src/Widgets/WindowSwitcher.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp1_, NULL);
#line 392 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 392 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp2_) {
#line 392 "../src/Widgets/WindowSwitcher.vala"
		_tmp0_ = self->priv->closing;
#line 1702 "WindowSwitcher.c"
	} else {
#line 392 "../src/Widgets/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 1706 "WindowSwitcher.c"
	}
#line 392 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp0_) {
#line 393 "../src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_close_cleanup (self);
#line 1712 "WindowSwitcher.c"
	}
#line 396 "../src/Widgets/WindowSwitcher.vala"
	self->priv->last_switch = now;
#line 398 "../src/Widgets/WindowSwitcher.vala"
	_tmp3_ = meta_screen_get_active_workspace (screen);
#line 398 "../src/Widgets/WindowSwitcher.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 398 "../src/Widgets/WindowSwitcher.vala"
	workspace = _tmp4_;
#line 399 "../src/Widgets/WindowSwitcher.vala"
	_tmp5_ = meta_key_binding_get_name (binding);
#line 399 "../src/Widgets/WindowSwitcher.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 399 "../src/Widgets/WindowSwitcher.vala"
	binding_name = _tmp6_;
#line 400 "../src/Widgets/WindowSwitcher.vala"
	_tmp7_ = binding_name;
#line 400 "../src/Widgets/WindowSwitcher.vala"
	backward = g_str_has_suffix (_tmp7_, "-backward");
#line 404 "../src/Widgets/WindowSwitcher.vala"
	_tmp8_ = binding_name;
#line 404 "../src/Widgets/WindowSwitcher.vala"
	if (g_strcmp0 (_tmp8_, "switch-applications") == 0) {
#line 405 "../src/Widgets/WindowSwitcher.vala"
		backward = (gala_window_switcher_get_current_modifiers (self) & CLUTTER_SHIFT_MASK) != 0;
#line 1738 "WindowSwitcher.c"
	}
#line 407 "../src/Widgets/WindowSwitcher.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp10_, NULL);
#line 407 "../src/Widgets/WindowSwitcher.vala"
	_tmp11_ = _tmp10_;
#line 407 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp11_) {
#line 407 "../src/Widgets/WindowSwitcher.vala"
		_tmp9_ = !self->priv->closing;
#line 1748 "WindowSwitcher.c"
	} else {
#line 407 "../src/Widgets/WindowSwitcher.vala"
		_tmp9_ = FALSE;
#line 1752 "WindowSwitcher.c"
	}
#line 407 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp9_) {
#line 1756 "WindowSwitcher.c"
		MetaWorkspace* _tmp12_;
		GalaWindowIcon* _tmp13_;
#line 408 "../src/Widgets/WindowSwitcher.vala"
		_tmp12_ = workspace;
#line 408 "../src/Widgets/WindowSwitcher.vala"
		_tmp13_ = gala_window_switcher_next_window (self, _tmp12_, backward);
#line 408 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->current_window);
#line 408 "../src/Widgets/WindowSwitcher.vala"
		self->priv->current_window = _tmp13_;
#line 409 "../src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_dim_windows (self);
#line 410 "../src/Widgets/WindowSwitcher.vala"
		_g_free0 (binding_name);
#line 410 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (workspace);
#line 410 "../src/Widgets/WindowSwitcher.vala"
		return;
#line 1775 "WindowSwitcher.c"
	}
#line 413 "../src/Widgets/WindowSwitcher.vala"
	_tmp14_ = workspace;
#line 413 "../src/Widgets/WindowSwitcher.vala"
	if (!gala_window_switcher_collect_windows (self, _tmp14_)) {
#line 414 "../src/Widgets/WindowSwitcher.vala"
		_g_free0 (binding_name);
#line 414 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (workspace);
#line 414 "../src/Widgets/WindowSwitcher.vala"
		return;
#line 1787 "WindowSwitcher.c"
	}
#line 416 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_set_primary_modifier (self, meta_key_binding_get_mask (binding));
#line 418 "../src/Widgets/WindowSwitcher.vala"
	_tmp15_ = workspace;
#line 418 "../src/Widgets/WindowSwitcher.vala"
	_tmp16_ = gala_window_switcher_next_window (self, _tmp15_, backward);
#line 418 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->current_window);
#line 418 "../src/Widgets/WindowSwitcher.vala"
	self->priv->current_window = _tmp16_;
#line 420 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_place_dock (self);
#line 422 "../src/Widgets/WindowSwitcher.vala"
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
#line 423 "../src/Widgets/WindowSwitcher.vala"
	self->priv->closing = FALSE;
#line 424 "../src/Widgets/WindowSwitcher.vala"
	_tmp17_ = self->priv->_wm;
#line 424 "../src/Widgets/WindowSwitcher.vala"
	_tmp18_ = gala_window_manager_push_modal (_tmp17_);
#line 424 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 424 "../src/Widgets/WindowSwitcher.vala"
	self->priv->modal_proxy = _tmp18_;
#line 425 "../src/Widgets/WindowSwitcher.vala"
	_tmp19_ = self->priv->modal_proxy;
#line 425 "../src/Widgets/WindowSwitcher.vala"
	gala_modal_proxy_set_keybinding_filter (_tmp19_, ___lambda44__gala_keybinding_filter, g_object_ref (self), g_object_unref);
#line 437 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_animate_dock_width (self);
#line 438 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_show_background (self);
#line 440 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_dim_windows (self);
#line 441 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_grab_key_focus ((ClutterActor*) self);
#line 443 "../src/Widgets/WindowSwitcher.vala"
	if ((gala_window_switcher_get_current_modifiers (self) & self->priv->modifier_mask) == 0) {
#line 1827 "WindowSwitcher.c"
		GalaWindowManager* _tmp20_;
		MetaScreen* _tmp21_;
		MetaDisplay* _tmp22_;
#line 444 "../src/Widgets/WindowSwitcher.vala"
		_tmp20_ = self->priv->_wm;
#line 444 "../src/Widgets/WindowSwitcher.vala"
		_tmp21_ = meta_plugin_get_screen ((MetaPlugin*) _tmp20_);
#line 444 "../src/Widgets/WindowSwitcher.vala"
		_tmp22_ = meta_screen_get_display (_tmp21_);
#line 444 "../src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_close (self, (guint) meta_display_get_current_time (_tmp22_));
#line 1839 "WindowSwitcher.c"
	}
#line 383 "../src/Widgets/WindowSwitcher.vala"
	_g_free0 (binding_name);
#line 383 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (workspace);
#line 1845 "WindowSwitcher.c"
}

static void
gala_window_switcher_close_cleanup (GalaWindowSwitcher* self)
{
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	MetaWorkspace* workspace = NULL;
	MetaScreen* _tmp3_;
	MetaWorkspace* _tmp4_;
	MetaWorkspace* _tmp5_;
	ClutterActor* _tmp6_;
	ClutterActor* _tmp7_;
	MetaScreen* _tmp8_;
	GList* _tmp9_;
#line 447 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 449 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 449 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 449 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 449 "../src/Widgets/WindowSwitcher.vala"
	screen = _tmp2_;
#line 450 "../src/Widgets/WindowSwitcher.vala"
	_tmp3_ = screen;
#line 450 "../src/Widgets/WindowSwitcher.vala"
	_tmp4_ = meta_screen_get_active_workspace (_tmp3_);
#line 450 "../src/Widgets/WindowSwitcher.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 450 "../src/Widgets/WindowSwitcher.vala"
	workspace = _tmp5_;
#line 452 "../src/Widgets/WindowSwitcher.vala"
	_tmp6_ = self->priv->dock;
#line 452 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_destroy_all_children (_tmp6_);
#line 454 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock_window);
#line 454 "../src/Widgets/WindowSwitcher.vala"
	self->priv->dock_window = NULL;
#line 455 "../src/Widgets/WindowSwitcher.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 456 "../src/Widgets/WindowSwitcher.vala"
	self->priv->closing = FALSE;
#line 458 "../src/Widgets/WindowSwitcher.vala"
	_tmp7_ = self->priv->window_clones;
#line 458 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_destroy_all_children (_tmp7_);
#line 461 "../src/Widgets/WindowSwitcher.vala"
	_tmp8_ = screen;
#line 461 "../src/Widgets/WindowSwitcher.vala"
	_tmp9_ = meta_get_window_actors (_tmp8_);
#line 1901 "WindowSwitcher.c"
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
#line 461 "../src/Widgets/WindowSwitcher.vala"
		actor_collection = _tmp9_;
#line 461 "../src/Widgets/WindowSwitcher.vala"
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
#line 1909 "WindowSwitcher.c"
			MetaWindowActor* actor = NULL;
#line 461 "../src/Widgets/WindowSwitcher.vala"
			actor = (MetaWindowActor*) actor_it->data;
#line 1913 "WindowSwitcher.c"
			{
				MetaWindowActor* _tmp10_;
				MetaWindow* window = NULL;
				MetaWindowActor* _tmp11_;
				MetaWindow* _tmp12_;
				gboolean _tmp13_ = FALSE;
				MetaWindow* _tmp14_;
				MetaWorkspace* _tmp15_;
				MetaWorkspace* _tmp16_;
#line 462 "../src/Widgets/WindowSwitcher.vala"
				_tmp10_ = actor;
#line 462 "../src/Widgets/WindowSwitcher.vala"
				if (meta_window_actor_is_destroyed (_tmp10_)) {
#line 463 "../src/Widgets/WindowSwitcher.vala"
					continue;
#line 1929 "WindowSwitcher.c"
				}
#line 465 "../src/Widgets/WindowSwitcher.vala"
				_tmp11_ = actor;
#line 465 "../src/Widgets/WindowSwitcher.vala"
				_tmp12_ = meta_window_actor_get_meta_window (_tmp11_);
#line 465 "../src/Widgets/WindowSwitcher.vala"
				window = _tmp12_;
#line 466 "../src/Widgets/WindowSwitcher.vala"
				_tmp14_ = window;
#line 466 "../src/Widgets/WindowSwitcher.vala"
				_tmp15_ = meta_window_get_workspace (_tmp14_);
#line 466 "../src/Widgets/WindowSwitcher.vala"
				_tmp16_ = workspace;
#line 466 "../src/Widgets/WindowSwitcher.vala"
				if (_tmp15_ == _tmp16_) {
#line 1945 "WindowSwitcher.c"
					MetaWindow* _tmp17_;
#line 467 "../src/Widgets/WindowSwitcher.vala"
					_tmp17_ = window;
#line 467 "../src/Widgets/WindowSwitcher.vala"
					_tmp13_ = meta_window_showing_on_its_workspace (_tmp17_);
#line 1951 "WindowSwitcher.c"
				} else {
#line 466 "../src/Widgets/WindowSwitcher.vala"
					_tmp13_ = FALSE;
#line 1955 "WindowSwitcher.c"
				}
#line 466 "../src/Widgets/WindowSwitcher.vala"
				if (_tmp13_) {
#line 1959 "WindowSwitcher.c"
					MetaWindowActor* _tmp18_;
#line 468 "../src/Widgets/WindowSwitcher.vala"
					_tmp18_ = actor;
#line 468 "../src/Widgets/WindowSwitcher.vala"
					clutter_actor_show ((ClutterActor*) _tmp18_);
#line 1965 "WindowSwitcher.c"
				}
			}
		}
	}
#line 447 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (workspace);
#line 447 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (screen);
#line 1974 "WindowSwitcher.c"
}

static void
___lambda43_ (GalaWindowSwitcher* self)
{
#line 544 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_close_cleanup (self);
#line 1982 "WindowSwitcher.c"
}

static void
____lambda43__clutter_timeline_completed (ClutterTimeline* _sender,
                                          gpointer self)
{
#line 544 "../src/Widgets/WindowSwitcher.vala"
	___lambda43_ ((GalaWindowSwitcher*) self);
#line 1991 "WindowSwitcher.c"
}

static void
gala_window_switcher_close (GalaWindowSwitcher* self,
                            guint time)
{
	GList* _tmp0_;
	GalaWindowIcon* _tmp22_;
	GalaWindowManager* _tmp26_;
	GalaModalProxy* _tmp27_;
	MetaWindowActor* _tmp28_;
	gfloat _tmp30_ = 0.0F;
	gfloat dest_width = 0.0F;
	ClutterActor* _tmp31_;
	MetaWindowActor* _tmp32_;
	ClutterActor* _tmp39_;
	ClutterActor* _tmp40_;
	ClutterActor* _tmp41_;
	PlankDockPreferences* _tmp42_;
	ClutterActor* _tmp47_;
	ClutterActor* _tmp48_;
	ClutterTransition* transition = NULL;
	ClutterActor* _tmp49_;
	ClutterTransition* _tmp50_;
	ClutterTransition* _tmp51_;
	ClutterTransition* _tmp52_;
#line 472 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 474 "../src/Widgets/WindowSwitcher.vala"
	if (self->priv->closing) {
#line 475 "../src/Widgets/WindowSwitcher.vala"
		return;
#line 2024 "WindowSwitcher.c"
	}
#line 477 "../src/Widgets/WindowSwitcher.vala"
	self->priv->closing = TRUE;
#line 478 "../src/Widgets/WindowSwitcher.vala"
	self->priv->last_switch = (gint64) 0;
#line 480 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->clone_sort_order;
#line 2032 "WindowSwitcher.c"
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
#line 480 "../src/Widgets/WindowSwitcher.vala"
		actor_collection = _tmp0_;
#line 480 "../src/Widgets/WindowSwitcher.vala"
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
#line 2040 "WindowSwitcher.c"
			ClutterActor* actor = NULL;
#line 480 "../src/Widgets/WindowSwitcher.vala"
			actor = (ClutterActor*) actor_it->data;
#line 2044 "WindowSwitcher.c"
			{
				GalaSafeWindowClone* clone = NULL;
				ClutterActor* _tmp1_;
				GalaSafeWindowClone* _tmp2_;
				MetaWindow* _tmp3_;
				MetaWindow* _tmp4_;
				GalaWindowIcon* _tmp5_;
				MetaWindow* _tmp6_;
				MetaWindow* _tmp7_;
				GalaSafeWindowClone* _tmp8_;
				ClutterActor* _tmp9_;
				GalaSafeWindowClone* _tmp10_;
				GalaSafeWindowClone* _tmp11_;
				MetaWindow* _tmp12_;
				MetaWindow* _tmp13_;
				gboolean _tmp14_;
				gboolean _tmp15_;
#line 481 "../src/Widgets/WindowSwitcher.vala"
				_tmp1_ = actor;
#line 481 "../src/Widgets/WindowSwitcher.vala"
				clone = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowClone);
#line 484 "../src/Widgets/WindowSwitcher.vala"
				_tmp2_ = clone;
#line 484 "../src/Widgets/WindowSwitcher.vala"
				_tmp3_ = gala_safe_window_clone_get_window (_tmp2_);
#line 484 "../src/Widgets/WindowSwitcher.vala"
				_tmp4_ = _tmp3_;
#line 484 "../src/Widgets/WindowSwitcher.vala"
				_tmp5_ = self->priv->current_window;
#line 484 "../src/Widgets/WindowSwitcher.vala"
				_tmp6_ = gala_window_icon_get_window (_tmp5_);
#line 484 "../src/Widgets/WindowSwitcher.vala"
				_tmp7_ = _tmp6_;
#line 484 "../src/Widgets/WindowSwitcher.vala"
				if (_tmp4_ == _tmp7_) {
#line 485 "../src/Widgets/WindowSwitcher.vala"
					continue;
#line 2082 "WindowSwitcher.c"
				}
#line 487 "../src/Widgets/WindowSwitcher.vala"
				_tmp8_ = clone;
#line 487 "../src/Widgets/WindowSwitcher.vala"
				clutter_actor_remove_effect_by_name ((ClutterActor*) _tmp8_, "brightness");
#line 490 "../src/Widgets/WindowSwitcher.vala"
				_tmp9_ = self->priv->window_clones;
#line 490 "../src/Widgets/WindowSwitcher.vala"
				_tmp10_ = clone;
#line 490 "../src/Widgets/WindowSwitcher.vala"
				clutter_actor_set_child_below_sibling (_tmp9_, (ClutterActor*) _tmp10_, NULL);
#line 492 "../src/Widgets/WindowSwitcher.vala"
				_tmp11_ = clone;
#line 492 "../src/Widgets/WindowSwitcher.vala"
				_tmp12_ = gala_safe_window_clone_get_window (_tmp11_);
#line 492 "../src/Widgets/WindowSwitcher.vala"
				_tmp13_ = _tmp12_;
#line 492 "../src/Widgets/WindowSwitcher.vala"
				g_object_get (_tmp13_, "minimized", &_tmp14_, NULL);
#line 492 "../src/Widgets/WindowSwitcher.vala"
				_tmp15_ = _tmp14_;
#line 492 "../src/Widgets/WindowSwitcher.vala"
				if (!_tmp15_) {
#line 2106 "WindowSwitcher.c"
					GalaSafeWindowClone* _tmp16_;
					GalaSafeWindowClone* _tmp17_;
					GalaSafeWindowClone* _tmp18_;
					GalaSafeWindowClone* _tmp19_;
					GalaSafeWindowClone* _tmp20_;
					GalaSafeWindowClone* _tmp21_;
#line 493 "../src/Widgets/WindowSwitcher.vala"
					_tmp16_ = clone;
#line 493 "../src/Widgets/WindowSwitcher.vala"
					clutter_actor_save_easing_state ((ClutterActor*) _tmp16_);
#line 494 "../src/Widgets/WindowSwitcher.vala"
					_tmp17_ = clone;
#line 494 "../src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_easing_duration ((ClutterActor*) _tmp17_, (guint) 150);
#line 495 "../src/Widgets/WindowSwitcher.vala"
					_tmp18_ = clone;
#line 495 "../src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_easing_mode ((ClutterActor*) _tmp18_, CLUTTER_EASE_OUT_CUBIC);
#line 496 "../src/Widgets/WindowSwitcher.vala"
					_tmp19_ = clone;
#line 496 "../src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_z_position ((ClutterActor*) _tmp19_, (gfloat) 0);
#line 497 "../src/Widgets/WindowSwitcher.vala"
					_tmp20_ = clone;
#line 497 "../src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_opacity ((ClutterActor*) _tmp20_, (guint) 255);
#line 498 "../src/Widgets/WindowSwitcher.vala"
					_tmp21_ = clone;
#line 498 "../src/Widgets/WindowSwitcher.vala"
					clutter_actor_restore_easing_state ((ClutterActor*) _tmp21_);
#line 2137 "WindowSwitcher.c"
				}
			}
		}
	}
#line 502 "../src/Widgets/WindowSwitcher.vala"
	_tmp22_ = self->priv->current_window;
#line 502 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp22_ != NULL) {
#line 2146 "WindowSwitcher.c"
		GalaWindowIcon* _tmp23_;
		MetaWindow* _tmp24_;
		MetaWindow* _tmp25_;
#line 503 "../src/Widgets/WindowSwitcher.vala"
		_tmp23_ = self->priv->current_window;
#line 503 "../src/Widgets/WindowSwitcher.vala"
		_tmp24_ = gala_window_icon_get_window (_tmp23_);
#line 503 "../src/Widgets/WindowSwitcher.vala"
		_tmp25_ = _tmp24_;
#line 503 "../src/Widgets/WindowSwitcher.vala"
		meta_window_activate (_tmp25_, (guint32) time);
#line 504 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->current_window);
#line 504 "../src/Widgets/WindowSwitcher.vala"
		self->priv->current_window = NULL;
#line 2162 "WindowSwitcher.c"
	}
#line 507 "../src/Widgets/WindowSwitcher.vala"
	_tmp26_ = self->priv->_wm;
#line 507 "../src/Widgets/WindowSwitcher.vala"
	_tmp27_ = self->priv->modal_proxy;
#line 507 "../src/Widgets/WindowSwitcher.vala"
	gala_window_manager_pop_modal (_tmp26_, _tmp27_);
#line 509 "../src/Widgets/WindowSwitcher.vala"
	_tmp28_ = self->priv->dock_window;
#line 509 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp28_ != NULL) {
#line 2174 "WindowSwitcher.c"
		MetaWindowActor* _tmp29_;
#line 510 "../src/Widgets/WindowSwitcher.vala"
		_tmp29_ = self->priv->dock_window;
#line 510 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_opacity ((ClutterActor*) _tmp29_, (guint) 0);
#line 2180 "WindowSwitcher.c"
	}
#line 512 "../src/Widgets/WindowSwitcher.vala"
	if (self->priv->dock_width > ((gfloat) 0)) {
#line 512 "../src/Widgets/WindowSwitcher.vala"
		_tmp30_ = self->priv->dock_width;
#line 2186 "WindowSwitcher.c"
	} else {
#line 512 "../src/Widgets/WindowSwitcher.vala"
		_tmp30_ = 600.0f;
#line 2190 "WindowSwitcher.c"
	}
#line 512 "../src/Widgets/WindowSwitcher.vala"
	dest_width = _tmp30_;
#line 514 "../src/Widgets/WindowSwitcher.vala"
	_tmp31_ = self->priv->dock;
#line 514 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_child_above_sibling ((ClutterActor*) self, _tmp31_, NULL);
#line 516 "../src/Widgets/WindowSwitcher.vala"
	_tmp32_ = self->priv->dock_window;
#line 516 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp32_ != NULL) {
#line 2202 "WindowSwitcher.c"
		MetaWindowActor* _tmp33_;
		MetaWindowActor* _tmp34_;
		MetaWindowActor* _tmp35_;
		MetaWindowActor* _tmp36_;
		MetaWindowActor* _tmp37_;
		MetaWindowActor* _tmp38_;
#line 517 "../src/Widgets/WindowSwitcher.vala"
		_tmp33_ = self->priv->dock_window;
#line 517 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_show ((ClutterActor*) _tmp33_);
#line 518 "../src/Widgets/WindowSwitcher.vala"
		_tmp34_ = self->priv->dock_window;
#line 518 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_save_easing_state ((ClutterActor*) _tmp34_);
#line 519 "../src/Widgets/WindowSwitcher.vala"
		_tmp35_ = self->priv->dock_window;
#line 519 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_easing_mode ((ClutterActor*) _tmp35_, CLUTTER_LINEAR);
#line 520 "../src/Widgets/WindowSwitcher.vala"
		_tmp36_ = self->priv->dock_window;
#line 520 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_easing_duration ((ClutterActor*) _tmp36_, (guint) 250);
#line 521 "../src/Widgets/WindowSwitcher.vala"
		_tmp37_ = self->priv->dock_window;
#line 521 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_opacity ((ClutterActor*) _tmp37_, (guint) 255);
#line 522 "../src/Widgets/WindowSwitcher.vala"
		_tmp38_ = self->priv->dock_window;
#line 522 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_restore_easing_state ((ClutterActor*) _tmp38_);
#line 2233 "WindowSwitcher.c"
	}
#line 525 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_hide_background (self);
#line 527 "../src/Widgets/WindowSwitcher.vala"
	_tmp39_ = self->priv->dock;
#line 527 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_save_easing_state (_tmp39_);
#line 528 "../src/Widgets/WindowSwitcher.vala"
	_tmp40_ = self->priv->dock;
#line 528 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_easing_duration (_tmp40_, (guint) 250);
#line 529 "../src/Widgets/WindowSwitcher.vala"
	_tmp41_ = self->priv->dock;
#line 529 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_easing_mode (_tmp41_, CLUTTER_EASE_OUT_CUBIC);
#line 531 "../src/Widgets/WindowSwitcher.vala"
	_tmp42_ = self->priv->dock_settings;
#line 531 "../src/Widgets/WindowSwitcher.vala"
	if (plank_dock_preferences_is_horizontal_dock (_tmp42_)) {
#line 2253 "WindowSwitcher.c"
		ClutterActor* _tmp43_;
		ClutterActor* _tmp44_;
#line 532 "../src/Widgets/WindowSwitcher.vala"
		_tmp43_ = self->priv->dock;
#line 532 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_width (_tmp43_, dest_width);
#line 533 "../src/Widgets/WindowSwitcher.vala"
		_tmp44_ = self->priv->dock;
#line 533 "../src/Widgets/WindowSwitcher.vala"
		g_object_set (_tmp44_, "translation-x", ceilf ((-dest_width) / 2.0f), NULL);
#line 2264 "WindowSwitcher.c"
	} else {
		ClutterActor* _tmp45_;
		ClutterActor* _tmp46_;
#line 535 "../src/Widgets/WindowSwitcher.vala"
		_tmp45_ = self->priv->dock;
#line 535 "../src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_height (_tmp45_, dest_width);
#line 536 "../src/Widgets/WindowSwitcher.vala"
		_tmp46_ = self->priv->dock;
#line 536 "../src/Widgets/WindowSwitcher.vala"
		g_object_set (_tmp46_, "translation-y", ceilf ((-dest_width) / 2.0f), NULL);
#line 2276 "WindowSwitcher.c"
	}
#line 539 "../src/Widgets/WindowSwitcher.vala"
	_tmp47_ = self->priv->dock;
#line 539 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_opacity (_tmp47_, (guint) 0);
#line 540 "../src/Widgets/WindowSwitcher.vala"
	_tmp48_ = self->priv->dock;
#line 540 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_restore_easing_state (_tmp48_);
#line 542 "../src/Widgets/WindowSwitcher.vala"
	_tmp49_ = self->priv->dock;
#line 542 "../src/Widgets/WindowSwitcher.vala"
	_tmp50_ = clutter_actor_get_transition (_tmp49_, "opacity");
#line 542 "../src/Widgets/WindowSwitcher.vala"
	_tmp51_ = _g_object_ref0 (_tmp50_);
#line 542 "../src/Widgets/WindowSwitcher.vala"
	transition = _tmp51_;
#line 543 "../src/Widgets/WindowSwitcher.vala"
	_tmp52_ = transition;
#line 543 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp52_ != NULL) {
#line 2298 "WindowSwitcher.c"
		ClutterTransition* _tmp53_;
#line 544 "../src/Widgets/WindowSwitcher.vala"
		_tmp53_ = transition;
#line 544 "../src/Widgets/WindowSwitcher.vala"
		g_signal_connect_object ((ClutterTimeline*) _tmp53_, "completed", (GCallback) ____lambda43__clutter_timeline_completed, self, 0);
#line 2304 "WindowSwitcher.c"
	} else {
#line 546 "../src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_close_cleanup (self);
#line 2308 "WindowSwitcher.c"
	}
#line 472 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (transition);
#line 2312 "WindowSwitcher.c"
}

static gboolean
_gala_window_switcher_clicked_icon_clutter_actor_button_release_event (ClutterActor* _sender,
                                                                       ClutterButtonEvent* event,
                                                                       gpointer self)
{
	gboolean result;
	result = gala_window_switcher_clicked_icon ((GalaWindowSwitcher*) self, event);
#line 570 "../src/Widgets/WindowSwitcher.vala"
	return result;
#line 2324 "WindowSwitcher.c"
}

static GalaWindowIcon*
gala_window_switcher_add_window (GalaWindowSwitcher* self,
                                 MetaWindow* window)
{
	GalaWindowIcon* result = NULL;
	MetaWindowActor* actor = NULL;
	GObject* _tmp0_;
	MetaWindowActor* _tmp1_;
	MetaWindowActor* _tmp2_;
	MetaWindowActor* _tmp3_;
	GalaSafeWindowClone* clone = NULL;
	GalaSafeWindowClone* _tmp4_;
	GalaSafeWindowClone* _tmp5_;
	MetaWindowActor* _tmp6_;
	gfloat _tmp7_;
	gfloat _tmp8_;
	GalaSafeWindowClone* _tmp9_;
	MetaWindowActor* _tmp10_;
	gfloat _tmp11_;
	gfloat _tmp12_;
	ClutterActor* _tmp13_;
	GalaSafeWindowClone* _tmp14_;
	GalaWindowIcon* icon = NULL;
	PlankDockPreferences* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	GalaWindowIcon* _tmp18_;
	GalaWindowIcon* _tmp19_;
	GalaWindowIcon* _tmp20_;
	GalaWindowIcon* _tmp21_;
	GalaWindowIcon* _tmp22_;
	GalaWindowIcon* _tmp23_;
	GalaWindowIcon* _tmp24_;
	GalaWindowIcon* _tmp25_;
	ClutterActor* _tmp26_;
	GalaWindowIcon* _tmp27_;
#line 549 "../src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 549 "../src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 551 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = meta_window_get_compositor_private (window);
#line 551 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, meta_window_actor_get_type ()) ? ((MetaWindowActor*) _tmp0_) : NULL);
#line 551 "../src/Widgets/WindowSwitcher.vala"
	actor = _tmp1_;
#line 552 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = actor;
#line 552 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp2_ == NULL) {
#line 553 "../src/Widgets/WindowSwitcher.vala"
		result = NULL;
#line 553 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (actor);
#line 553 "../src/Widgets/WindowSwitcher.vala"
		return result;
#line 2383 "WindowSwitcher.c"
	}
#line 555 "../src/Widgets/WindowSwitcher.vala"
	_tmp3_ = actor;
#line 555 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_hide ((ClutterActor*) _tmp3_);
#line 557 "../src/Widgets/WindowSwitcher.vala"
	_tmp4_ = gala_safe_window_clone_new (window, TRUE);
#line 557 "../src/Widgets/WindowSwitcher.vala"
	g_object_ref_sink (_tmp4_);
#line 557 "../src/Widgets/WindowSwitcher.vala"
	clone = _tmp4_;
#line 558 "../src/Widgets/WindowSwitcher.vala"
	_tmp5_ = clone;
#line 558 "../src/Widgets/WindowSwitcher.vala"
	_tmp6_ = actor;
#line 558 "../src/Widgets/WindowSwitcher.vala"
	_tmp7_ = clutter_actor_get_x ((ClutterActor*) _tmp6_);
#line 558 "../src/Widgets/WindowSwitcher.vala"
	_tmp8_ = _tmp7_;
#line 558 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_x ((ClutterActor*) _tmp5_, _tmp8_);
#line 559 "../src/Widgets/WindowSwitcher.vala"
	_tmp9_ = clone;
#line 559 "../src/Widgets/WindowSwitcher.vala"
	_tmp10_ = actor;
#line 559 "../src/Widgets/WindowSwitcher.vala"
	_tmp11_ = clutter_actor_get_y ((ClutterActor*) _tmp10_);
#line 559 "../src/Widgets/WindowSwitcher.vala"
	_tmp12_ = _tmp11_;
#line 559 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_y ((ClutterActor*) _tmp9_, _tmp12_);
#line 561 "../src/Widgets/WindowSwitcher.vala"
	_tmp13_ = self->priv->window_clones;
#line 561 "../src/Widgets/WindowSwitcher.vala"
	_tmp14_ = clone;
#line 561 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_add_child (_tmp13_, (ClutterActor*) _tmp14_);
#line 563 "../src/Widgets/WindowSwitcher.vala"
	_tmp15_ = self->priv->dock_settings;
#line 563 "../src/Widgets/WindowSwitcher.vala"
	_tmp16_ = plank_dock_preferences_get_IconSize (_tmp15_);
#line 563 "../src/Widgets/WindowSwitcher.vala"
	_tmp17_ = _tmp16_;
#line 563 "../src/Widgets/WindowSwitcher.vala"
	_tmp18_ = gala_window_icon_new (window, _tmp17_, self->priv->ui_scale_factor, TRUE);
#line 563 "../src/Widgets/WindowSwitcher.vala"
	g_object_ref_sink (_tmp18_);
#line 563 "../src/Widgets/WindowSwitcher.vala"
	icon = _tmp18_;
#line 564 "../src/Widgets/WindowSwitcher.vala"
	_tmp19_ = icon;
#line 564 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_reactive ((ClutterActor*) _tmp19_, TRUE);
#line 565 "../src/Widgets/WindowSwitcher.vala"
	_tmp20_ = icon;
#line 565 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp20_, (guint) 100);
#line 566 "../src/Widgets/WindowSwitcher.vala"
	_tmp21_ = icon;
#line 566 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_x_expand ((ClutterActor*) _tmp21_, TRUE);
#line 567 "../src/Widgets/WindowSwitcher.vala"
	_tmp22_ = icon;
#line 567 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_y_expand ((ClutterActor*) _tmp22_, TRUE);
#line 568 "../src/Widgets/WindowSwitcher.vala"
	_tmp23_ = icon;
#line 568 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_x_align ((ClutterActor*) _tmp23_, CLUTTER_ACTOR_ALIGN_CENTER);
#line 569 "../src/Widgets/WindowSwitcher.vala"
	_tmp24_ = icon;
#line 569 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_y_align ((ClutterActor*) _tmp24_, CLUTTER_ACTOR_ALIGN_CENTER);
#line 570 "../src/Widgets/WindowSwitcher.vala"
	_tmp25_ = icon;
#line 570 "../src/Widgets/WindowSwitcher.vala"
	g_signal_connect_object ((ClutterActor*) _tmp25_, "button-release-event", (GCallback) _gala_window_switcher_clicked_icon_clutter_actor_button_release_event, self, 0);
#line 572 "../src/Widgets/WindowSwitcher.vala"
	_tmp26_ = self->priv->dock;
#line 572 "../src/Widgets/WindowSwitcher.vala"
	_tmp27_ = icon;
#line 572 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_add_child (_tmp26_, (ClutterActor*) _tmp27_);
#line 574 "../src/Widgets/WindowSwitcher.vala"
	result = icon;
#line 574 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (clone);
#line 574 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (actor);
#line 574 "../src/Widgets/WindowSwitcher.vala"
	return result;
#line 2475 "WindowSwitcher.c"
}

static void
gala_window_switcher_dim_windows (GalaWindowSwitcher* self)
{
	ClutterActor* _tmp0_;
	GList* _tmp1_;
	ClutterActor* _tmp24_;
	GList* _tmp25_;
#line 577 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 579 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->window_clones;
#line 579 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = clutter_actor_get_children (_tmp0_);
#line 2491 "WindowSwitcher.c"
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
#line 579 "../src/Widgets/WindowSwitcher.vala"
		actor_collection = _tmp1_;
#line 579 "../src/Widgets/WindowSwitcher.vala"
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
#line 2499 "WindowSwitcher.c"
			ClutterActor* actor = NULL;
#line 579 "../src/Widgets/WindowSwitcher.vala"
			actor = (ClutterActor*) actor_it->data;
#line 2503 "WindowSwitcher.c"
			{
				GalaSafeWindowClone* clone = NULL;
				ClutterActor* _tmp2_;
				ClutterActor* _tmp3_;
				ClutterActor* _tmp4_;
				ClutterActor* _tmp5_;
				GalaSafeWindowClone* _tmp6_;
				MetaWindow* _tmp7_;
				MetaWindow* _tmp8_;
				GalaWindowIcon* _tmp9_;
				MetaWindow* _tmp10_;
				MetaWindow* _tmp11_;
				ClutterActor* _tmp23_;
#line 580 "../src/Widgets/WindowSwitcher.vala"
				_tmp2_ = actor;
#line 580 "../src/Widgets/WindowSwitcher.vala"
				clone = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowClone);
#line 582 "../src/Widgets/WindowSwitcher.vala"
				_tmp3_ = actor;
#line 582 "../src/Widgets/WindowSwitcher.vala"
				clutter_actor_save_easing_state (_tmp3_);
#line 583 "../src/Widgets/WindowSwitcher.vala"
				_tmp4_ = actor;
#line 583 "../src/Widgets/WindowSwitcher.vala"
				clutter_actor_set_easing_duration (_tmp4_, (guint) 250);
#line 584 "../src/Widgets/WindowSwitcher.vala"
				_tmp5_ = actor;
#line 584 "../src/Widgets/WindowSwitcher.vala"
				clutter_actor_set_easing_mode (_tmp5_, CLUTTER_EASE_IN_OUT_QUART);
#line 586 "../src/Widgets/WindowSwitcher.vala"
				_tmp6_ = clone;
#line 586 "../src/Widgets/WindowSwitcher.vala"
				_tmp7_ = gala_safe_window_clone_get_window (_tmp6_);
#line 586 "../src/Widgets/WindowSwitcher.vala"
				_tmp8_ = _tmp7_;
#line 586 "../src/Widgets/WindowSwitcher.vala"
				_tmp9_ = self->priv->current_window;
#line 586 "../src/Widgets/WindowSwitcher.vala"
				_tmp10_ = gala_window_icon_get_window (_tmp9_);
#line 586 "../src/Widgets/WindowSwitcher.vala"
				_tmp11_ = _tmp10_;
#line 586 "../src/Widgets/WindowSwitcher.vala"
				if (_tmp8_ == _tmp11_) {
#line 2547 "WindowSwitcher.c"
					ClutterActor* _tmp12_;
					ClutterActor* _tmp13_;
					ClutterActor* _tmp14_;
					ClutterActor* _tmp15_;
#line 587 "../src/Widgets/WindowSwitcher.vala"
					_tmp12_ = self->priv->window_clones;
#line 587 "../src/Widgets/WindowSwitcher.vala"
					_tmp13_ = actor;
#line 587 "../src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_child_above_sibling (_tmp12_, _tmp13_, NULL);
#line 588 "../src/Widgets/WindowSwitcher.vala"
					_tmp14_ = actor;
#line 588 "../src/Widgets/WindowSwitcher.vala"
					clutter_actor_remove_effect_by_name (_tmp14_, "brightness");
#line 589 "../src/Widgets/WindowSwitcher.vala"
					_tmp15_ = actor;
#line 589 "../src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_z_position (_tmp15_, (gfloat) 0);
#line 2566 "WindowSwitcher.c"
				} else {
					ClutterActor* _tmp16_;
					ClutterEffect* _tmp17_;
					ClutterActor* _tmp22_;
#line 591 "../src/Widgets/WindowSwitcher.vala"
					_tmp16_ = actor;
#line 591 "../src/Widgets/WindowSwitcher.vala"
					_tmp17_ = clutter_actor_get_effect (_tmp16_, "brightness");
#line 591 "../src/Widgets/WindowSwitcher.vala"
					if (_tmp17_ == NULL) {
#line 2577 "WindowSwitcher.c"
						ClutterBrightnessContrastEffect* brightness_effect = NULL;
						ClutterBrightnessContrastEffect* _tmp18_;
						ClutterBrightnessContrastEffect* _tmp19_;
						ClutterActor* _tmp20_;
						ClutterBrightnessContrastEffect* _tmp21_;
#line 592 "../src/Widgets/WindowSwitcher.vala"
						_tmp18_ = (ClutterBrightnessContrastEffect*) clutter_brightness_contrast_effect_new ();
#line 592 "../src/Widgets/WindowSwitcher.vala"
						g_object_ref_sink (_tmp18_);
#line 592 "../src/Widgets/WindowSwitcher.vala"
						brightness_effect = _tmp18_;
#line 593 "../src/Widgets/WindowSwitcher.vala"
						_tmp19_ = brightness_effect;
#line 593 "../src/Widgets/WindowSwitcher.vala"
						clutter_brightness_contrast_effect_set_brightness (_tmp19_, GALA_WINDOW_SWITCHER_DIM_WINDOW_BRIGHTNESS);
#line 594 "../src/Widgets/WindowSwitcher.vala"
						_tmp20_ = actor;
#line 594 "../src/Widgets/WindowSwitcher.vala"
						_tmp21_ = brightness_effect;
#line 594 "../src/Widgets/WindowSwitcher.vala"
						clutter_actor_add_effect_with_name (_tmp20_, "brightness", (ClutterEffect*) _tmp21_);
#line 591 "../src/Widgets/WindowSwitcher.vala"
						_g_object_unref0 (brightness_effect);
#line 2601 "WindowSwitcher.c"
					}
#line 597 "../src/Widgets/WindowSwitcher.vala"
					_tmp22_ = actor;
#line 597 "../src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_z_position (_tmp22_, (gfloat) -100);
#line 2607 "WindowSwitcher.c"
				}
#line 600 "../src/Widgets/WindowSwitcher.vala"
				_tmp23_ = actor;
#line 600 "../src/Widgets/WindowSwitcher.vala"
				clutter_actor_restore_easing_state (_tmp23_);
#line 2613 "WindowSwitcher.c"
			}
		}
#line 579 "../src/Widgets/WindowSwitcher.vala"
		(actor_collection == NULL) ? NULL : (actor_collection = (g_list_free (actor_collection), NULL));
#line 2618 "WindowSwitcher.c"
	}
#line 603 "../src/Widgets/WindowSwitcher.vala"
	_tmp24_ = self->priv->dock;
#line 603 "../src/Widgets/WindowSwitcher.vala"
	_tmp25_ = clutter_actor_get_children (_tmp24_);
#line 2624 "WindowSwitcher.c"
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
#line 603 "../src/Widgets/WindowSwitcher.vala"
		actor_collection = _tmp25_;
#line 603 "../src/Widgets/WindowSwitcher.vala"
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
#line 2632 "WindowSwitcher.c"
			ClutterActor* actor = NULL;
#line 603 "../src/Widgets/WindowSwitcher.vala"
			actor = (ClutterActor*) actor_it->data;
#line 2636 "WindowSwitcher.c"
			{
				GalaWindowIcon* icon = NULL;
				ClutterActor* _tmp26_;
				GalaWindowIcon* _tmp27_;
				GalaWindowIcon* _tmp28_;
				GalaWindowIcon* _tmp29_;
				GalaWindowIcon* _tmp30_;
				GalaWindowIcon* _tmp31_;
				GalaWindowIcon* _tmp34_;
#line 604 "../src/Widgets/WindowSwitcher.vala"
				_tmp26_ = actor;
#line 604 "../src/Widgets/WindowSwitcher.vala"
				icon = G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
#line 605 "../src/Widgets/WindowSwitcher.vala"
				_tmp27_ = icon;
#line 605 "../src/Widgets/WindowSwitcher.vala"
				clutter_actor_save_easing_state ((ClutterActor*) _tmp27_);
#line 606 "../src/Widgets/WindowSwitcher.vala"
				_tmp28_ = icon;
#line 606 "../src/Widgets/WindowSwitcher.vala"
				clutter_actor_set_easing_duration ((ClutterActor*) _tmp28_, (guint) 100);
#line 607 "../src/Widgets/WindowSwitcher.vala"
				_tmp29_ = icon;
#line 607 "../src/Widgets/WindowSwitcher.vala"
				clutter_actor_set_easing_mode ((ClutterActor*) _tmp29_, CLUTTER_LINEAR);
#line 609 "../src/Widgets/WindowSwitcher.vala"
				_tmp30_ = icon;
#line 609 "../src/Widgets/WindowSwitcher.vala"
				_tmp31_ = self->priv->current_window;
#line 609 "../src/Widgets/WindowSwitcher.vala"
				if (_tmp30_ == _tmp31_) {
#line 2668 "WindowSwitcher.c"
					GalaWindowIcon* _tmp32_;
#line 610 "../src/Widgets/WindowSwitcher.vala"
					_tmp32_ = icon;
#line 610 "../src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_opacity ((ClutterActor*) _tmp32_, (guint) 255);
#line 2674 "WindowSwitcher.c"
				} else {
					GalaWindowIcon* _tmp33_;
#line 612 "../src/Widgets/WindowSwitcher.vala"
					_tmp33_ = icon;
#line 612 "../src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_opacity ((ClutterActor*) _tmp33_, (guint) 100);
#line 2681 "WindowSwitcher.c"
				}
#line 614 "../src/Widgets/WindowSwitcher.vala"
				_tmp34_ = icon;
#line 614 "../src/Widgets/WindowSwitcher.vala"
				clutter_actor_restore_easing_state ((ClutterActor*) _tmp34_);
#line 2687 "WindowSwitcher.c"
			}
		}
#line 603 "../src/Widgets/WindowSwitcher.vala"
		(actor_collection == NULL) ? NULL : (actor_collection = (g_list_free (actor_collection), NULL));
#line 2692 "WindowSwitcher.c"
	}
}

/**
 * Adds the suitable windows on the given workspace to the switcher
 *
 * @return whether the switcher should actually be started or if there are
 *         not enough windows
 */
static gboolean
_vala_string_array_contains (gchar* * stack,
                             int stack_length,
                             const gchar* needle)
{
	int i;
#line 671 "../src/Widgets/WindowSwitcher.vala"
	for (i = 0; i < stack_length; i++) {
#line 671 "../src/Widgets/WindowSwitcher.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 671 "../src/Widgets/WindowSwitcher.vala"
			return TRUE;
#line 2714 "WindowSwitcher.c"
		}
	}
#line 671 "../src/Widgets/WindowSwitcher.vala"
	return FALSE;
#line 2719 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_collect_windows (GalaWindowSwitcher* self,
                                      MetaWorkspace* workspace)
{
	gboolean result = FALSE;
	MetaScreen* screen = NULL;
	MetaScreen* _tmp0_;
	MetaScreen* _tmp1_;
	MetaDisplay* display = NULL;
	MetaScreen* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaDisplay* _tmp4_;
	GList* windows = NULL;
	MetaDisplay* _tmp5_;
	GList* _tmp6_;
	MetaWindow* current = NULL;
	MetaDisplay* _tmp7_;
	MetaWindow* _tmp8_;
	MetaWindow* _tmp9_;
	GList* _tmp10_;
	GList* _tmp11_;
	GList* _tmp22_;
	ClutterActor* _tmp29_;
	GList* _tmp30_;
	GList* _tmp31_;
	GList* _tmp32_;
	GalaWindowIcon* _tmp33_;
	MetaScreen* _tmp37_;
	GList* _tmp38_;
#line 624 "../src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 624 "../src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (workspace != NULL, FALSE);
#line 626 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = meta_workspace_get_screen (workspace);
#line 626 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 626 "../src/Widgets/WindowSwitcher.vala"
	screen = _tmp1_;
#line 627 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = screen;
#line 627 "../src/Widgets/WindowSwitcher.vala"
	_tmp3_ = meta_screen_get_display (_tmp2_);
#line 627 "../src/Widgets/WindowSwitcher.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 627 "../src/Widgets/WindowSwitcher.vala"
	display = _tmp4_;
#line 629 "../src/Widgets/WindowSwitcher.vala"
	_tmp5_ = display;
#line 629 "../src/Widgets/WindowSwitcher.vala"
	_tmp6_ = meta_display_get_tab_list (_tmp5_, META_TAB_LIST_NORMAL, workspace);
#line 629 "../src/Widgets/WindowSwitcher.vala"
	windows = _tmp6_;
#line 630 "../src/Widgets/WindowSwitcher.vala"
	_tmp7_ = display;
#line 630 "../src/Widgets/WindowSwitcher.vala"
	_tmp8_ = meta_display_get_tab_current (_tmp7_, META_TAB_LIST_NORMAL, workspace);
#line 630 "../src/Widgets/WindowSwitcher.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 630 "../src/Widgets/WindowSwitcher.vala"
	current = _tmp9_;
#line 632 "../src/Widgets/WindowSwitcher.vala"
	_tmp10_ = windows;
#line 632 "../src/Widgets/WindowSwitcher.vala"
	if (g_list_length (_tmp10_) < ((guint) 1)) {
#line 633 "../src/Widgets/WindowSwitcher.vala"
		result = FALSE;
#line 633 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (current);
#line 633 "../src/Widgets/WindowSwitcher.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 633 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (display);
#line 633 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (screen);
#line 633 "../src/Widgets/WindowSwitcher.vala"
		return result;
#line 2799 "WindowSwitcher.c"
	}
#line 635 "../src/Widgets/WindowSwitcher.vala"
	_tmp11_ = windows;
#line 635 "../src/Widgets/WindowSwitcher.vala"
	if (g_list_length (_tmp11_) == ((guint) 1)) {
#line 2805 "WindowSwitcher.c"
		MetaWindow* window = NULL;
		GList* _tmp12_;
		gconstpointer _tmp13_;
		MetaWindow* _tmp14_;
		MetaWindow* _tmp15_;
		gboolean _tmp16_;
		gboolean _tmp17_;
		MetaWindow* _tmp20_;
		MetaDisplay* _tmp21_;
#line 636 "../src/Widgets/WindowSwitcher.vala"
		_tmp12_ = windows;
#line 636 "../src/Widgets/WindowSwitcher.vala"
		_tmp13_ = _tmp12_->data;
#line 636 "../src/Widgets/WindowSwitcher.vala"
		_tmp14_ = _g_object_ref0 ((MetaWindow*) _tmp13_);
#line 636 "../src/Widgets/WindowSwitcher.vala"
		window = _tmp14_;
#line 637 "../src/Widgets/WindowSwitcher.vala"
		_tmp15_ = window;
#line 637 "../src/Widgets/WindowSwitcher.vala"
		g_object_get (_tmp15_, "minimized", &_tmp16_, NULL);
#line 637 "../src/Widgets/WindowSwitcher.vala"
		_tmp17_ = _tmp16_;
#line 637 "../src/Widgets/WindowSwitcher.vala"
		if (_tmp17_) {
#line 2831 "WindowSwitcher.c"
			MetaWindow* _tmp18_;
#line 638 "../src/Widgets/WindowSwitcher.vala"
			_tmp18_ = window;
#line 638 "../src/Widgets/WindowSwitcher.vala"
			meta_window_unminimize (_tmp18_);
#line 2837 "WindowSwitcher.c"
		} else {
			MetaScreen* _tmp19_;
#line 640 "../src/Widgets/WindowSwitcher.vala"
			_tmp19_ = screen;
#line 640 "../src/Widgets/WindowSwitcher.vala"
			gala_utils_bell (_tmp19_);
#line 2844 "WindowSwitcher.c"
		}
#line 642 "../src/Widgets/WindowSwitcher.vala"
		_tmp20_ = window;
#line 642 "../src/Widgets/WindowSwitcher.vala"
		_tmp21_ = display;
#line 642 "../src/Widgets/WindowSwitcher.vala"
		meta_window_activate (_tmp20_, meta_display_get_current_time (_tmp21_));
#line 644 "../src/Widgets/WindowSwitcher.vala"
		result = FALSE;
#line 644 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (window);
#line 644 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (current);
#line 644 "../src/Widgets/WindowSwitcher.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 644 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (display);
#line 644 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (screen);
#line 644 "../src/Widgets/WindowSwitcher.vala"
		return result;
#line 2866 "WindowSwitcher.c"
	}
#line 647 "../src/Widgets/WindowSwitcher.vala"
	_tmp22_ = windows;
#line 2870 "WindowSwitcher.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 647 "../src/Widgets/WindowSwitcher.vala"
		window_collection = _tmp22_;
#line 647 "../src/Widgets/WindowSwitcher.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 2878 "WindowSwitcher.c"
			MetaWindow* window = NULL;
#line 647 "../src/Widgets/WindowSwitcher.vala"
			window = (MetaWindow*) window_it->data;
#line 2882 "WindowSwitcher.c"
			{
				GalaWindowIcon* clone = NULL;
				MetaWindow* _tmp23_;
				GalaWindowIcon* _tmp24_;
				MetaWindow* _tmp25_;
				MetaWindow* _tmp26_;
#line 648 "../src/Widgets/WindowSwitcher.vala"
				_tmp23_ = window;
#line 648 "../src/Widgets/WindowSwitcher.vala"
				_tmp24_ = gala_window_switcher_add_window (self, _tmp23_);
#line 648 "../src/Widgets/WindowSwitcher.vala"
				clone = _tmp24_;
#line 649 "../src/Widgets/WindowSwitcher.vala"
				_tmp25_ = window;
#line 649 "../src/Widgets/WindowSwitcher.vala"
				_tmp26_ = current;
#line 649 "../src/Widgets/WindowSwitcher.vala"
				if (_tmp25_ == _tmp26_) {
#line 2901 "WindowSwitcher.c"
					GalaWindowIcon* _tmp27_;
					GalaWindowIcon* _tmp28_;
#line 650 "../src/Widgets/WindowSwitcher.vala"
					_tmp27_ = clone;
#line 650 "../src/Widgets/WindowSwitcher.vala"
					_tmp28_ = _g_object_ref0 (_tmp27_);
#line 650 "../src/Widgets/WindowSwitcher.vala"
					_g_object_unref0 (self->priv->current_window);
#line 650 "../src/Widgets/WindowSwitcher.vala"
					self->priv->current_window = _tmp28_;
#line 2912 "WindowSwitcher.c"
				}
#line 647 "../src/Widgets/WindowSwitcher.vala"
				_g_object_unref0 (clone);
#line 2916 "WindowSwitcher.c"
			}
		}
	}
#line 653 "../src/Widgets/WindowSwitcher.vala"
	_tmp29_ = self->priv->window_clones;
#line 653 "../src/Widgets/WindowSwitcher.vala"
	_tmp30_ = clutter_actor_get_children (_tmp29_);
#line 653 "../src/Widgets/WindowSwitcher.vala"
	_tmp31_ = _tmp30_;
#line 653 "../src/Widgets/WindowSwitcher.vala"
	_tmp32_ = g_list_copy (_tmp31_);
#line 653 "../src/Widgets/WindowSwitcher.vala"
	(self->priv->clone_sort_order == NULL) ? NULL : (self->priv->clone_sort_order = (g_list_free (self->priv->clone_sort_order), NULL));
#line 653 "../src/Widgets/WindowSwitcher.vala"
	self->priv->clone_sort_order = _tmp32_;
#line 653 "../src/Widgets/WindowSwitcher.vala"
	(_tmp31_ == NULL) ? NULL : (_tmp31_ = (g_list_free (_tmp31_), NULL));
#line 655 "../src/Widgets/WindowSwitcher.vala"
	_tmp33_ = self->priv->current_window;
#line 655 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp33_ == NULL) {
#line 2938 "WindowSwitcher.c"
		ClutterActor* _tmp34_;
		ClutterActor* _tmp35_;
		GalaWindowIcon* _tmp36_;
#line 656 "../src/Widgets/WindowSwitcher.vala"
		_tmp34_ = self->priv->dock;
#line 656 "../src/Widgets/WindowSwitcher.vala"
		_tmp35_ = clutter_actor_get_child_at_index (_tmp34_, 0);
#line 656 "../src/Widgets/WindowSwitcher.vala"
		_tmp36_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon));
#line 656 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->current_window);
#line 656 "../src/Widgets/WindowSwitcher.vala"
		self->priv->current_window = _tmp36_;
#line 2952 "WindowSwitcher.c"
	}
#line 659 "../src/Widgets/WindowSwitcher.vala"
	_tmp37_ = screen;
#line 659 "../src/Widgets/WindowSwitcher.vala"
	_tmp38_ = meta_get_window_actors (_tmp37_);
#line 2958 "WindowSwitcher.c"
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
#line 659 "../src/Widgets/WindowSwitcher.vala"
		actor_collection = _tmp38_;
#line 659 "../src/Widgets/WindowSwitcher.vala"
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
#line 2966 "WindowSwitcher.c"
			MetaWindowActor* actor = NULL;
#line 659 "../src/Widgets/WindowSwitcher.vala"
			actor = (MetaWindowActor*) actor_it->data;
#line 2970 "WindowSwitcher.c"
			{
				MetaWindowActor* _tmp39_;
				MetaWindow* window = NULL;
				MetaWindowActor* _tmp40_;
				MetaWindow* _tmp41_;
				MetaWindowType type = 0;
				MetaWindow* _tmp42_;
				MetaWindowType _tmp43_;
				MetaWindowType _tmp44_;
				gboolean _tmp45_ = FALSE;
				gboolean _tmp46_ = FALSE;
				MetaWindowType _tmp47_;
				gboolean _tmp51_ = FALSE;
				MetaWindow* _tmp52_;
				const gchar* _tmp53_;
				const gchar* _tmp54_;
				GalaBehaviorSettings* _tmp55_;
				gchar** _tmp56_;
				gint _tmp56__length1;
				gchar** _tmp57_;
				gint _tmp57__length1;
#line 660 "../src/Widgets/WindowSwitcher.vala"
				_tmp39_ = actor;
#line 660 "../src/Widgets/WindowSwitcher.vala"
				if (meta_window_actor_is_destroyed (_tmp39_)) {
#line 661 "../src/Widgets/WindowSwitcher.vala"
					continue;
#line 2998 "WindowSwitcher.c"
				}
#line 663 "../src/Widgets/WindowSwitcher.vala"
				_tmp40_ = actor;
#line 663 "../src/Widgets/WindowSwitcher.vala"
				_tmp41_ = meta_window_actor_get_meta_window (_tmp40_);
#line 663 "../src/Widgets/WindowSwitcher.vala"
				window = _tmp41_;
#line 664 "../src/Widgets/WindowSwitcher.vala"
				_tmp42_ = window;
#line 664 "../src/Widgets/WindowSwitcher.vala"
				_tmp43_ = meta_window_get_window_type (_tmp42_);
#line 664 "../src/Widgets/WindowSwitcher.vala"
				_tmp44_ = _tmp43_;
#line 664 "../src/Widgets/WindowSwitcher.vala"
				type = _tmp44_;
#line 666 "../src/Widgets/WindowSwitcher.vala"
				_tmp47_ = type;
#line 666 "../src/Widgets/WindowSwitcher.vala"
				if (_tmp47_ != META_WINDOW_DOCK) {
#line 3018 "WindowSwitcher.c"
					MetaWindowType _tmp48_;
#line 667 "../src/Widgets/WindowSwitcher.vala"
					_tmp48_ = type;
#line 667 "../src/Widgets/WindowSwitcher.vala"
					_tmp46_ = _tmp48_ != META_WINDOW_DESKTOP;
#line 3024 "WindowSwitcher.c"
				} else {
#line 666 "../src/Widgets/WindowSwitcher.vala"
					_tmp46_ = FALSE;
#line 3028 "WindowSwitcher.c"
				}
#line 666 "../src/Widgets/WindowSwitcher.vala"
				if (_tmp46_) {
#line 3032 "WindowSwitcher.c"
					MetaWindowType _tmp49_;
#line 668 "../src/Widgets/WindowSwitcher.vala"
					_tmp49_ = type;
#line 668 "../src/Widgets/WindowSwitcher.vala"
					_tmp45_ = _tmp49_ != META_WINDOW_NOTIFICATION;
#line 3038 "WindowSwitcher.c"
				} else {
#line 666 "../src/Widgets/WindowSwitcher.vala"
					_tmp45_ = FALSE;
#line 3042 "WindowSwitcher.c"
				}
#line 666 "../src/Widgets/WindowSwitcher.vala"
				if (_tmp45_) {
#line 3046 "WindowSwitcher.c"
					MetaWindowActor* _tmp50_;
#line 669 "../src/Widgets/WindowSwitcher.vala"
					_tmp50_ = actor;
#line 669 "../src/Widgets/WindowSwitcher.vala"
					clutter_actor_hide ((ClutterActor*) _tmp50_);
#line 3052 "WindowSwitcher.c"
				}
#line 671 "../src/Widgets/WindowSwitcher.vala"
				_tmp52_ = window;
#line 671 "../src/Widgets/WindowSwitcher.vala"
				_tmp53_ = meta_window_get_title (_tmp52_);
#line 671 "../src/Widgets/WindowSwitcher.vala"
				_tmp54_ = _tmp53_;
#line 671 "../src/Widgets/WindowSwitcher.vala"
				_tmp55_ = gala_behavior_settings_get_default ();
#line 671 "../src/Widgets/WindowSwitcher.vala"
				_tmp56_ = gala_behavior_settings_get_dock_names (_tmp55_, &_tmp56__length1);
#line 671 "../src/Widgets/WindowSwitcher.vala"
				_tmp57_ = _tmp56_;
#line 671 "../src/Widgets/WindowSwitcher.vala"
				_tmp57__length1 = _tmp56__length1;
#line 671 "../src/Widgets/WindowSwitcher.vala"
				if (_vala_string_array_contains (_tmp57_, _tmp57__length1, _tmp54_)) {
#line 3070 "WindowSwitcher.c"
					MetaWindowType _tmp58_;
#line 672 "../src/Widgets/WindowSwitcher.vala"
					_tmp58_ = type;
#line 672 "../src/Widgets/WindowSwitcher.vala"
					_tmp51_ = _tmp58_ == META_WINDOW_DOCK;
#line 3076 "WindowSwitcher.c"
				} else {
#line 671 "../src/Widgets/WindowSwitcher.vala"
					_tmp51_ = FALSE;
#line 3080 "WindowSwitcher.c"
				}
#line 671 "../src/Widgets/WindowSwitcher.vala"
				if (_tmp51_) {
#line 3084 "WindowSwitcher.c"
					MetaWindowActor* _tmp59_;
					MetaWindowActor* _tmp60_;
					MetaWindowActor* _tmp61_;
#line 673 "../src/Widgets/WindowSwitcher.vala"
					_tmp59_ = actor;
#line 673 "../src/Widgets/WindowSwitcher.vala"
					_tmp60_ = _g_object_ref0 (_tmp59_);
#line 673 "../src/Widgets/WindowSwitcher.vala"
					_g_object_unref0 (self->priv->dock_window);
#line 673 "../src/Widgets/WindowSwitcher.vala"
					self->priv->dock_window = _tmp60_;
#line 674 "../src/Widgets/WindowSwitcher.vala"
					_tmp61_ = self->priv->dock_window;
#line 674 "../src/Widgets/WindowSwitcher.vala"
					clutter_actor_hide ((ClutterActor*) _tmp61_);
#line 3100 "WindowSwitcher.c"
				}
			}
		}
	}
#line 678 "../src/Widgets/WindowSwitcher.vala"
	result = TRUE;
#line 678 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (current);
#line 678 "../src/Widgets/WindowSwitcher.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 678 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (display);
#line 678 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (screen);
#line 678 "../src/Widgets/WindowSwitcher.vala"
	return result;
#line 3117 "WindowSwitcher.c"
}

static GalaWindowIcon*
gala_window_switcher_next_window (GalaWindowSwitcher* self,
                                  MetaWorkspace* workspace,
                                  gboolean backward)
{
	GalaWindowIcon* result = NULL;
	ClutterActor* actor = NULL;
	ClutterActor* _tmp14_;
	GalaWindowIcon* _tmp15_;
#line 681 "../src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 681 "../src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (workspace != NULL, NULL);
#line 684 "../src/Widgets/WindowSwitcher.vala"
	if (!backward) {
#line 3135 "WindowSwitcher.c"
		GalaWindowIcon* _tmp0_;
		ClutterActor* _tmp1_;
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
#line 685 "../src/Widgets/WindowSwitcher.vala"
		_tmp0_ = self->priv->current_window;
#line 685 "../src/Widgets/WindowSwitcher.vala"
		_tmp1_ = clutter_actor_get_next_sibling ((ClutterActor*) _tmp0_);
#line 685 "../src/Widgets/WindowSwitcher.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 685 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (actor);
#line 685 "../src/Widgets/WindowSwitcher.vala"
		actor = _tmp2_;
#line 686 "../src/Widgets/WindowSwitcher.vala"
		_tmp3_ = actor;
#line 686 "../src/Widgets/WindowSwitcher.vala"
		if (_tmp3_ == NULL) {
#line 3154 "WindowSwitcher.c"
			ClutterActor* _tmp4_;
			ClutterActor* _tmp5_;
			ClutterActor* _tmp6_;
#line 687 "../src/Widgets/WindowSwitcher.vala"
			_tmp4_ = self->priv->dock;
#line 687 "../src/Widgets/WindowSwitcher.vala"
			_tmp5_ = clutter_actor_get_first_child (_tmp4_);
#line 687 "../src/Widgets/WindowSwitcher.vala"
			_tmp6_ = _g_object_ref0 (_tmp5_);
#line 687 "../src/Widgets/WindowSwitcher.vala"
			_g_object_unref0 (actor);
#line 687 "../src/Widgets/WindowSwitcher.vala"
			actor = _tmp6_;
#line 3168 "WindowSwitcher.c"
		}
	} else {
		GalaWindowIcon* _tmp7_;
		ClutterActor* _tmp8_;
		ClutterActor* _tmp9_;
		ClutterActor* _tmp10_;
#line 689 "../src/Widgets/WindowSwitcher.vala"
		_tmp7_ = self->priv->current_window;
#line 689 "../src/Widgets/WindowSwitcher.vala"
		_tmp8_ = clutter_actor_get_previous_sibling ((ClutterActor*) _tmp7_);
#line 689 "../src/Widgets/WindowSwitcher.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 689 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (actor);
#line 689 "../src/Widgets/WindowSwitcher.vala"
		actor = _tmp9_;
#line 690 "../src/Widgets/WindowSwitcher.vala"
		_tmp10_ = actor;
#line 690 "../src/Widgets/WindowSwitcher.vala"
		if (_tmp10_ == NULL) {
#line 3189 "WindowSwitcher.c"
			ClutterActor* _tmp11_;
			ClutterActor* _tmp12_;
			ClutterActor* _tmp13_;
#line 691 "../src/Widgets/WindowSwitcher.vala"
			_tmp11_ = self->priv->dock;
#line 691 "../src/Widgets/WindowSwitcher.vala"
			_tmp12_ = clutter_actor_get_last_child (_tmp11_);
#line 691 "../src/Widgets/WindowSwitcher.vala"
			_tmp13_ = _g_object_ref0 (_tmp12_);
#line 691 "../src/Widgets/WindowSwitcher.vala"
			_g_object_unref0 (actor);
#line 691 "../src/Widgets/WindowSwitcher.vala"
			actor = _tmp13_;
#line 3203 "WindowSwitcher.c"
		}
	}
#line 694 "../src/Widgets/WindowSwitcher.vala"
	_tmp14_ = actor;
#line 694 "../src/Widgets/WindowSwitcher.vala"
	_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon));
#line 694 "../src/Widgets/WindowSwitcher.vala"
	result = _tmp15_;
#line 694 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (actor);
#line 694 "../src/Widgets/WindowSwitcher.vala"
	return result;
#line 3216 "WindowSwitcher.c"
}

/**
 * copied from gnome-shell, finds the primary modifier in the mask and saves it
 * to our modifier_mask field
 *
 * @param mask The modifier mask to extract the primary one from
 */
static void
gala_window_switcher_set_primary_modifier (GalaWindowSwitcher* self,
                                           guint mask)
{
#line 703 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 705 "../src/Widgets/WindowSwitcher.vala"
	if (mask == ((guint) 0)) {
#line 706 "../src/Widgets/WindowSwitcher.vala"
		self->priv->modifier_mask = (guint) 0;
#line 3235 "WindowSwitcher.c"
	} else {
#line 708 "../src/Widgets/WindowSwitcher.vala"
		self->priv->modifier_mask = (guint) 1;
#line 709 "../src/Widgets/WindowSwitcher.vala"
		while (TRUE) {
#line 709 "../src/Widgets/WindowSwitcher.vala"
			if (!(mask > ((guint) 1))) {
#line 709 "../src/Widgets/WindowSwitcher.vala"
				break;
#line 3245 "WindowSwitcher.c"
			}
#line 710 "../src/Widgets/WindowSwitcher.vala"
			mask = mask >> 1;
#line 711 "../src/Widgets/WindowSwitcher.vala"
			self->priv->modifier_mask = self->priv->modifier_mask << 1;
#line 3251 "WindowSwitcher.c"
		}
	}
}

/**
 * Counts the launcher items to get an estimate of the window size
 */
static void
gala_window_switcher_update_n_dock_items (GalaWindowSwitcher* self,
                                          GFile* folder,
                                          GFile* other_file,
                                          GFileMonitorEvent event)
{
	gboolean _tmp0_ = FALSE;
	gint count = 0;
	GError * _inner_error_ = NULL;
#line 719 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 719 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (folder != NULL);
#line 721 "../src/Widgets/WindowSwitcher.vala"
	if (event != G_FILE_MONITOR_EVENT_CREATED) {
#line 721 "../src/Widgets/WindowSwitcher.vala"
		_tmp0_ = event != G_FILE_MONITOR_EVENT_DELETED;
#line 3276 "WindowSwitcher.c"
	} else {
#line 721 "../src/Widgets/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 3280 "WindowSwitcher.c"
	}
#line 721 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp0_) {
#line 722 "../src/Widgets/WindowSwitcher.vala"
		return;
#line 3286 "WindowSwitcher.c"
	}
#line 724 "../src/Widgets/WindowSwitcher.vala"
	count = 0;
#line 3290 "WindowSwitcher.c"
	{
		GFileEnumerator* children = NULL;
		GFileEnumerator* _tmp1_;
#line 727 "../src/Widgets/WindowSwitcher.vala"
		_tmp1_ = g_file_enumerate_children (folder, "", 0, NULL, &_inner_error_);
#line 727 "../src/Widgets/WindowSwitcher.vala"
		children = _tmp1_;
#line 727 "../src/Widgets/WindowSwitcher.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3300 "WindowSwitcher.c"
			goto __catch27_g_error;
		}
#line 728 "../src/Widgets/WindowSwitcher.vala"
		while (TRUE) {
#line 3305 "WindowSwitcher.c"
			GFileInfo* _tmp2_ = NULL;
			GFileEnumerator* _tmp3_;
			GFileInfo* _tmp4_;
			gint _tmp5_;
#line 728 "../src/Widgets/WindowSwitcher.vala"
			_tmp3_ = children;
#line 728 "../src/Widgets/WindowSwitcher.vala"
			_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error_);
#line 728 "../src/Widgets/WindowSwitcher.vala"
			_tmp2_ = _tmp4_;
#line 728 "../src/Widgets/WindowSwitcher.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 728 "../src/Widgets/WindowSwitcher.vala"
				_g_object_unref0 (children);
#line 3320 "WindowSwitcher.c"
				goto __catch27_g_error;
			}
#line 728 "../src/Widgets/WindowSwitcher.vala"
			if (!(_tmp2_ != NULL)) {
#line 728 "../src/Widgets/WindowSwitcher.vala"
				_g_object_unref0 (_tmp2_);
#line 728 "../src/Widgets/WindowSwitcher.vala"
				break;
#line 3329 "WindowSwitcher.c"
			}
#line 729 "../src/Widgets/WindowSwitcher.vala"
			_tmp5_ = count;
#line 729 "../src/Widgets/WindowSwitcher.vala"
			count = _tmp5_ + 1;
#line 728 "../src/Widgets/WindowSwitcher.vala"
			_g_object_unref0 (_tmp2_);
#line 3337 "WindowSwitcher.c"
		}
#line 726 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (children);
#line 3341 "WindowSwitcher.c"
	}
	goto __finally27;
	__catch27_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 726 "../src/Widgets/WindowSwitcher.vala"
		e = _inner_error_;
#line 726 "../src/Widgets/WindowSwitcher.vala"
		_inner_error_ = NULL;
#line 731 "../src/Widgets/WindowSwitcher.vala"
		_tmp6_ = e;
#line 731 "../src/Widgets/WindowSwitcher.vala"
		_tmp7_ = _tmp6_->message;
#line 731 "../src/Widgets/WindowSwitcher.vala"
		g_warning ("WindowSwitcher.vala:731: %s", _tmp7_);
#line 726 "../src/Widgets/WindowSwitcher.vala"
		_g_error_free0 (e);
#line 3361 "WindowSwitcher.c"
	}
	__finally27:
#line 726 "../src/Widgets/WindowSwitcher.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 726 "../src/Widgets/WindowSwitcher.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 726 "../src/Widgets/WindowSwitcher.vala"
		g_clear_error (&_inner_error_);
#line 726 "../src/Widgets/WindowSwitcher.vala"
		return;
#line 3372 "WindowSwitcher.c"
	}
#line 733 "../src/Widgets/WindowSwitcher.vala"
	self->priv->n_dock_items = count;
#line 3376 "WindowSwitcher.c"
}

static GdkModifierType
gala_window_switcher_get_current_modifiers (GalaWindowSwitcher* self)
{
	GdkModifierType result = 0;
	GdkModifierType modifiers = 0;
	gdouble* axes = NULL;
	gdouble* _tmp0_;
	gint axes_length1;
	gint _axes_size_;
	GdkDisplay* _tmp1_;
	GdkDeviceManager* _tmp2_;
	GdkDevice* _tmp3_;
	GdkWindow* _tmp4_;
	GdkModifierType _tmp5_ = 0;
#line 736 "../src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 739 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = g_new0 (gdouble, 0);
#line 739 "../src/Widgets/WindowSwitcher.vala"
	axes = _tmp0_;
#line 739 "../src/Widgets/WindowSwitcher.vala"
	axes_length1 = 0;
#line 739 "../src/Widgets/WindowSwitcher.vala"
	_axes_size_ = axes_length1;
#line 740 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = gdk_display_get_default ();
#line 740 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = gdk_display_get_device_manager (_tmp1_);
#line 740 "../src/Widgets/WindowSwitcher.vala"
	_tmp3_ = gdk_device_manager_get_client_pointer (_tmp2_);
#line 740 "../src/Widgets/WindowSwitcher.vala"
	_tmp4_ = gdk_get_default_root_window ();
#line 740 "../src/Widgets/WindowSwitcher.vala"
	gdk_device_get_state (_tmp3_, _tmp4_, axes, &_tmp5_);
#line 740 "../src/Widgets/WindowSwitcher.vala"
	modifiers = _tmp5_;
#line 743 "../src/Widgets/WindowSwitcher.vala"
	result = modifiers;
#line 743 "../src/Widgets/WindowSwitcher.vala"
	axes = (g_free (axes), NULL);
#line 743 "../src/Widgets/WindowSwitcher.vala"
	return result;
#line 3421 "WindowSwitcher.c"
}

GalaWindowManager*
gala_window_switcher_get_wm (GalaWindowSwitcher* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 29 "../src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 29 "../src/Widgets/WindowSwitcher.vala"
	result = _tmp0_;
#line 29 "../src/Widgets/WindowSwitcher.vala"
	return result;
#line 3437 "WindowSwitcher.c"
}

static void
gala_window_switcher_set_wm (GalaWindowSwitcher* self,
                             GalaWindowManager* value)
{
#line 29 "../src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Widgets/WindowSwitcher.vala"
	if (gala_window_switcher_get_wm (self) != value) {
#line 3448 "WindowSwitcher.c"
		GalaWindowManager* _tmp0_;
#line 29 "../src/Widgets/WindowSwitcher.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->_wm);
#line 29 "../src/Widgets/WindowSwitcher.vala"
		self->priv->_wm = _tmp0_;
#line 29 "../src/Widgets/WindowSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_WM_PROPERTY]);
#line 3458 "WindowSwitcher.c"
	}
}

static Block45Data*
block45_data_ref (Block45Data* _data45_)
{
#line 62 "../src/Widgets/WindowSwitcher.vala"
	g_atomic_int_inc (&_data45_->_ref_count_);
#line 62 "../src/Widgets/WindowSwitcher.vala"
	return _data45_;
#line 3469 "WindowSwitcher.c"
}

static void
block45_data_unref (void * _userdata_)
{
	Block45Data* _data45_;
	_data45_ = (Block45Data*) _userdata_;
#line 62 "../src/Widgets/WindowSwitcher.vala"
	if (g_atomic_int_dec_and_test (&_data45_->_ref_count_)) {
#line 3479 "WindowSwitcher.c"
		GalaWindowSwitcher* self;
#line 62 "../src/Widgets/WindowSwitcher.vala"
		self = _data45_->self;
#line 62 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (_data45_->dock_canvas);
#line 62 "../src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (self);
#line 62 "../src/Widgets/WindowSwitcher.vala"
		g_slice_free (Block45Data, _data45_);
#line 3489 "WindowSwitcher.c"
	}
}

static void
_gala_window_switcher_load_dock_theme_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
#line 67 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_load_dock_theme ((GalaWindowSwitcher*) self);
#line 3500 "WindowSwitcher.c"
}

static void
_gala_window_switcher_update_n_dock_items_g_file_monitor_changed (GFileMonitor* _sender,
                                                                  GFile* file,
                                                                  GFile* other_file,
                                                                  GFileMonitorEvent event_type,
                                                                  gpointer self)
{
#line 74 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_update_n_dock_items ((GalaWindowSwitcher*) self, file, other_file, event_type);
#line 3512 "WindowSwitcher.c"
}

static gboolean
_gala_window_switcher_draw_dock_background_clutter_canvas_draw (ClutterCanvas* _sender,
                                                                cairo_t* cr,
                                                                gint width,
                                                                gint height,
                                                                gpointer self)
{
	gboolean result;
	result = gala_window_switcher_draw_dock_background ((GalaWindowSwitcher*) self, cr);
#line 87 "../src/Widgets/WindowSwitcher.vala"
	return result;
#line 3526 "WindowSwitcher.c"
}

static void
_gala_window_switcher_icon_removed_clutter_container_actor_removed (ClutterContainer* _sender,
                                                                    ClutterActor* actor,
                                                                    gpointer self)
{
#line 90 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_icon_removed ((GalaWindowSwitcher*) self, actor);
#line 3536 "WindowSwitcher.c"
}

static void
_gala_window_switcher___lambda45_ (Block45Data* _data45_)
{
	GalaWindowSwitcher* self;
	ClutterCanvas* _tmp0_;
	ClutterActor* _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	ClutterActor* _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
#line 91 "../src/Widgets/WindowSwitcher.vala"
	self = _data45_->self;
#line 91 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = _data45_->dock_canvas;
#line 91 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = self->priv->dock;
#line 91 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = clutter_actor_get_width (_tmp1_);
#line 91 "../src/Widgets/WindowSwitcher.vala"
	_tmp3_ = _tmp2_;
#line 91 "../src/Widgets/WindowSwitcher.vala"
	_tmp4_ = self->priv->dock;
#line 91 "../src/Widgets/WindowSwitcher.vala"
	_tmp5_ = clutter_actor_get_height (_tmp4_);
#line 91 "../src/Widgets/WindowSwitcher.vala"
	_tmp6_ = _tmp5_;
#line 91 "../src/Widgets/WindowSwitcher.vala"
	clutter_canvas_set_size (_tmp0_, (gint) _tmp3_, (gint) _tmp6_);
#line 3568 "WindowSwitcher.c"
}

static void
__gala_window_switcher___lambda45__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 91 "../src/Widgets/WindowSwitcher.vala"
	_gala_window_switcher___lambda45_ (self);
#line 3578 "WindowSwitcher.c"
}

static void
_gala_window_switcher_window_removed_clutter_container_actor_removed (ClutterContainer* _sender,
                                                                      ClutterActor* actor,
                                                                      gpointer self)
{
#line 97 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_window_removed ((GalaWindowSwitcher*) self, actor);
#line 3588 "WindowSwitcher.c"
}

static GObject *
gala_window_switcher_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowSwitcher * self;
	Block45Data* _data45_;
	PlankDockPreferences* _tmp0_;
	PlankDockPreferences* _tmp1_;
	PlankDockPreferences* _tmp2_;
	GFile* launcher_folder = NULL;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	ClutterActor* _tmp18_;
	ClutterActor* _tmp19_;
	ClutterBoxLayout* _tmp20_;
	ClutterBoxLayout* _tmp21_;
	ClutterCanvas* _tmp22_;
	ClutterCanvas* _tmp23_;
	ClutterActor* _tmp24_;
	ClutterCanvas* _tmp25_;
	ClutterActor* _tmp26_;
	ClutterActor* _tmp27_;
	ClutterActor* _tmp28_;
	ClutterActor* _tmp29_;
	ClutterActor* _tmp30_;
	ClutterActor* _tmp31_;
	ClutterActor* _tmp32_;
	ClutterActor* _tmp33_;
	ClutterActor* _tmp34_;
	GalaWindowManager* _tmp35_;
	MetaScreen* _tmp36_;
	GError * _inner_error_ = NULL;
#line 62 "../src/Widgets/WindowSwitcher.vala"
	parent_class = G_OBJECT_CLASS (gala_window_switcher_parent_class);
#line 62 "../src/Widgets/WindowSwitcher.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 62 "../src/Widgets/WindowSwitcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 62 "../src/Widgets/WindowSwitcher.vala"
	_data45_ = g_slice_new0 (Block45Data);
#line 62 "../src/Widgets/WindowSwitcher.vala"
	_data45_->_ref_count_ = 1;
#line 62 "../src/Widgets/WindowSwitcher.vala"
	_data45_->self = g_object_ref (self);
#line 65 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = plank_dock_preferences_new ("dock1");
#line 65 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock_settings);
#line 65 "../src/Widgets/WindowSwitcher.vala"
	self->priv->dock_settings = _tmp0_;
#line 66 "../src/Widgets/WindowSwitcher.vala"
	_tmp1_ = self->priv->dock_settings;
#line 66 "../src/Widgets/WindowSwitcher.vala"
	g_signal_connect_object ((GObject*) _tmp1_, "notify", (GCallback) _gala_window_switcher_update_dock_g_object_notify, self, 0);
#line 67 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = self->priv->dock_settings;
#line 67 "../src/Widgets/WindowSwitcher.vala"
	g_signal_connect_object ((GObject*) _tmp2_, "notify::Theme", (GCallback) _gala_window_switcher_load_dock_theme_g_object_notify, self, 0);
#line 69 "../src/Widgets/WindowSwitcher.vala"
	_tmp3_ = plank_paths_get_AppConfigFolder ();
#line 69 "../src/Widgets/WindowSwitcher.vala"
	_tmp4_ = _tmp3_;
#line 69 "../src/Widgets/WindowSwitcher.vala"
	_tmp5_ = g_file_get_child (_tmp4_, "dock1");
#line 69 "../src/Widgets/WindowSwitcher.vala"
	_tmp6_ = _tmp5_;
#line 69 "../src/Widgets/WindowSwitcher.vala"
	_tmp7_ = g_file_get_child (_tmp6_, "launchers");
#line 69 "../src/Widgets/WindowSwitcher.vala"
	_tmp8_ = _tmp7_;
#line 69 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (_tmp6_);
#line 69 "../src/Widgets/WindowSwitcher.vala"
	launcher_folder = _tmp8_;
#line 71 "../src/Widgets/WindowSwitcher.vala"
	_tmp9_ = launcher_folder;
#line 71 "../src/Widgets/WindowSwitcher.vala"
	if (g_file_query_exists (_tmp9_, NULL)) {
#line 3677 "WindowSwitcher.c"
		GFile* _tmp17_;
		{
			GFileMonitor* _tmp10_ = NULL;
			GFile* _tmp11_;
			GFileMonitor* _tmp12_;
			GFileMonitor* _tmp13_;
			GFileMonitor* _tmp14_;
#line 73 "../src/Widgets/WindowSwitcher.vala"
			_tmp11_ = launcher_folder;
#line 73 "../src/Widgets/WindowSwitcher.vala"
			_tmp12_ = g_file_monitor (_tmp11_, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
#line 73 "../src/Widgets/WindowSwitcher.vala"
			_tmp10_ = _tmp12_;
#line 73 "../src/Widgets/WindowSwitcher.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3693 "WindowSwitcher.c"
				goto __catch28_g_error;
			}
#line 73 "../src/Widgets/WindowSwitcher.vala"
			_tmp13_ = _tmp10_;
#line 73 "../src/Widgets/WindowSwitcher.vala"
			_tmp10_ = NULL;
#line 73 "../src/Widgets/WindowSwitcher.vala"
			_g_object_unref0 (self->priv->monitor);
#line 73 "../src/Widgets/WindowSwitcher.vala"
			self->priv->monitor = _tmp13_;
#line 74 "../src/Widgets/WindowSwitcher.vala"
			_tmp14_ = self->priv->monitor;
#line 74 "../src/Widgets/WindowSwitcher.vala"
			g_signal_connect_object (_tmp14_, "changed", (GCallback) _gala_window_switcher_update_n_dock_items_g_file_monitor_changed, self, 0);
#line 72 "../src/Widgets/WindowSwitcher.vala"
			_g_object_unref0 (_tmp10_);
#line 3710 "WindowSwitcher.c"
		}
		goto __finally28;
		__catch28_g_error:
		{
			GError* e = NULL;
			GError* _tmp15_;
			const gchar* _tmp16_;
#line 72 "../src/Widgets/WindowSwitcher.vala"
			e = _inner_error_;
#line 72 "../src/Widgets/WindowSwitcher.vala"
			_inner_error_ = NULL;
#line 75 "../src/Widgets/WindowSwitcher.vala"
			_tmp15_ = e;
#line 75 "../src/Widgets/WindowSwitcher.vala"
			_tmp16_ = _tmp15_->message;
#line 75 "../src/Widgets/WindowSwitcher.vala"
			g_warning ("WindowSwitcher.vala:75: %s", _tmp16_);
#line 72 "../src/Widgets/WindowSwitcher.vala"
			_g_error_free0 (e);
#line 3730 "WindowSwitcher.c"
		}
		__finally28:
#line 72 "../src/Widgets/WindowSwitcher.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 72 "../src/Widgets/WindowSwitcher.vala"
			_g_object_unref0 (launcher_folder);
#line 72 "../src/Widgets/WindowSwitcher.vala"
			block45_data_unref (_data45_);
#line 72 "../src/Widgets/WindowSwitcher.vala"
			_data45_ = NULL;
#line 72 "../src/Widgets/WindowSwitcher.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 72 "../src/Widgets/WindowSwitcher.vala"
			g_clear_error (&_inner_error_);
#line 3745 "WindowSwitcher.c"
		}
#line 78 "../src/Widgets/WindowSwitcher.vala"
		_tmp17_ = launcher_folder;
#line 78 "../src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_update_n_dock_items (self, _tmp17_, NULL, G_FILE_MONITOR_EVENT_CREATED);
#line 3751 "WindowSwitcher.c"
	}
#line 81 "../src/Widgets/WindowSwitcher.vala"
	self->priv->ui_scale_factor = gala_internal_utils_get_ui_scaling_factor ();
#line 83 "../src/Widgets/WindowSwitcher.vala"
	_tmp18_ = clutter_actor_new ();
#line 83 "../src/Widgets/WindowSwitcher.vala"
	g_object_ref_sink (_tmp18_);
#line 83 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock);
#line 83 "../src/Widgets/WindowSwitcher.vala"
	self->priv->dock = _tmp18_;
#line 84 "../src/Widgets/WindowSwitcher.vala"
	_tmp19_ = self->priv->dock;
#line 84 "../src/Widgets/WindowSwitcher.vala"
	_tmp20_ = (ClutterBoxLayout*) clutter_box_layout_new ();
#line 84 "../src/Widgets/WindowSwitcher.vala"
	g_object_ref_sink (_tmp20_);
#line 84 "../src/Widgets/WindowSwitcher.vala"
	_tmp21_ = _tmp20_;
#line 84 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_layout_manager (_tmp19_, (ClutterLayoutManager*) _tmp21_);
#line 84 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (_tmp21_);
#line 86 "../src/Widgets/WindowSwitcher.vala"
	_tmp22_ = (ClutterCanvas*) clutter_canvas_new ();
#line 86 "../src/Widgets/WindowSwitcher.vala"
	_data45_->dock_canvas = _tmp22_;
#line 87 "../src/Widgets/WindowSwitcher.vala"
	_tmp23_ = _data45_->dock_canvas;
#line 87 "../src/Widgets/WindowSwitcher.vala"
	g_signal_connect_object (_tmp23_, "draw", (GCallback) _gala_window_switcher_draw_dock_background_clutter_canvas_draw, self, 0);
#line 89 "../src/Widgets/WindowSwitcher.vala"
	_tmp24_ = self->priv->dock;
#line 89 "../src/Widgets/WindowSwitcher.vala"
	_tmp25_ = _data45_->dock_canvas;
#line 89 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_content (_tmp24_, (ClutterContent*) _tmp25_);
#line 90 "../src/Widgets/WindowSwitcher.vala"
	_tmp26_ = self->priv->dock;
#line 90 "../src/Widgets/WindowSwitcher.vala"
	g_signal_connect_object ((ClutterContainer*) _tmp26_, "actor-removed", (GCallback) _gala_window_switcher_icon_removed_clutter_container_actor_removed, self, 0);
#line 91 "../src/Widgets/WindowSwitcher.vala"
	_tmp27_ = self->priv->dock;
#line 91 "../src/Widgets/WindowSwitcher.vala"
	g_signal_connect_data ((GObject*) _tmp27_, "notify::allocation", (GCallback) __gala_window_switcher___lambda45__g_object_notify, block45_data_ref (_data45_), (GClosureNotify) block45_data_unref, 0);
#line 94 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_load_dock_theme (self);
#line 96 "../src/Widgets/WindowSwitcher.vala"
	_tmp28_ = clutter_actor_new ();
#line 96 "../src/Widgets/WindowSwitcher.vala"
	g_object_ref_sink (_tmp28_);
#line 96 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->window_clones);
#line 96 "../src/Widgets/WindowSwitcher.vala"
	self->priv->window_clones = _tmp28_;
#line 97 "../src/Widgets/WindowSwitcher.vala"
	_tmp29_ = self->priv->window_clones;
#line 97 "../src/Widgets/WindowSwitcher.vala"
	g_signal_connect_object ((ClutterContainer*) _tmp29_, "actor-removed", (GCallback) _gala_window_switcher_window_removed_clutter_container_actor_removed, self, 0);
#line 99 "../src/Widgets/WindowSwitcher.vala"
	_tmp30_ = clutter_actor_new ();
#line 99 "../src/Widgets/WindowSwitcher.vala"
	g_object_ref_sink (_tmp30_);
#line 99 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->background);
#line 99 "../src/Widgets/WindowSwitcher.vala"
	self->priv->background = _tmp30_;
#line 100 "../src/Widgets/WindowSwitcher.vala"
	_tmp31_ = self->priv->background;
#line 100 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_background_color (_tmp31_, clutter_color_get_static (CLUTTER_COLOR_BLACK));
#line 101 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_update_background (self);
#line 103 "../src/Widgets/WindowSwitcher.vala"
	_tmp32_ = self->priv->background;
#line 103 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp32_);
#line 104 "../src/Widgets/WindowSwitcher.vala"
	_tmp33_ = self->priv->window_clones;
#line 104 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp33_);
#line 105 "../src/Widgets/WindowSwitcher.vala"
	_tmp34_ = self->priv->dock;
#line 105 "../src/Widgets/WindowSwitcher.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp34_);
#line 107 "../src/Widgets/WindowSwitcher.vala"
	_tmp35_ = self->priv->_wm;
#line 107 "../src/Widgets/WindowSwitcher.vala"
	_tmp36_ = meta_plugin_get_screen ((MetaPlugin*) _tmp35_);
#line 107 "../src/Widgets/WindowSwitcher.vala"
	g_signal_connect_object (_tmp36_, "monitors-changed", (GCallback) _gala_window_switcher_update_actors_meta_screen_monitors_changed, self, 0);
#line 109 "../src/Widgets/WindowSwitcher.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 62 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (launcher_folder);
#line 62 "../src/Widgets/WindowSwitcher.vala"
	block45_data_unref (_data45_);
#line 62 "../src/Widgets/WindowSwitcher.vala"
	_data45_ = NULL;
#line 62 "../src/Widgets/WindowSwitcher.vala"
	return obj;
#line 3853 "WindowSwitcher.c"
}

static void
gala_window_switcher_class_init (GalaWindowSwitcherClass * klass,
                                 gpointer klass_data)
{
#line 23 "../src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Widgets/WindowSwitcher.vala"
	g_type_class_adjust_private_offset (klass, &GalaWindowSwitcher_private_offset);
#line 23 "../src/Widgets/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->key_release_event = (gboolean (*) (ClutterActor*, ClutterKeyEvent*)) gala_window_switcher_real_key_release_event;
#line 23 "../src/Widgets/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->key_focus_out = (void (*) (ClutterActor*)) gala_window_switcher_real_key_focus_out;
#line 23 "../src/Widgets/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_switcher_get_property;
#line 23 "../src/Widgets/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_switcher_set_property;
#line 23 "../src/Widgets/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_switcher_constructor;
#line 23 "../src/Widgets/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_switcher_finalize;
#line 23 "../src/Widgets/WindowSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_SWITCHER_WM_PROPERTY, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 3878 "WindowSwitcher.c"
}

static void
gala_window_switcher_instance_init (GalaWindowSwitcher * self,
                                    gpointer klass)
{
#line 23 "../src/Widgets/WindowSwitcher.vala"
	self->priv = gala_window_switcher_get_instance_private (self);
#line 31 "../src/Widgets/WindowSwitcher.vala"
	self->priv->current_window = NULL;
#line 43 "../src/Widgets/WindowSwitcher.vala"
	self->priv->ui_scale_factor = 1;
#line 49 "../src/Widgets/WindowSwitcher.vala"
	self->priv->last_switch = (gint64) 0;
#line 50 "../src/Widgets/WindowSwitcher.vala"
	self->priv->closing = FALSE;
#line 54 "../src/Widgets/WindowSwitcher.vala"
	self->priv->dock_width = 0.0f;
#line 55 "../src/Widgets/WindowSwitcher.vala"
	self->priv->n_dock_items = 0;
#line 3899 "WindowSwitcher.c"
}

static void
gala_window_switcher_finalize (GObject * obj)
{
	GalaWindowSwitcher * self;
	GFileMonitor* _tmp0_;
	GalaWindowManager* _tmp2_;
	MetaScreen* _tmp3_;
	guint _tmp4_;
#line 23 "../src/Widgets/WindowSwitcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 114 "../src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->monitor;
#line 114 "../src/Widgets/WindowSwitcher.vala"
	if (_tmp0_ != NULL) {
#line 3916 "WindowSwitcher.c"
		GFileMonitor* _tmp1_;
#line 115 "../src/Widgets/WindowSwitcher.vala"
		_tmp1_ = self->priv->monitor;
#line 115 "../src/Widgets/WindowSwitcher.vala"
		g_file_monitor_cancel (_tmp1_);
#line 3922 "WindowSwitcher.c"
	}
#line 117 "../src/Widgets/WindowSwitcher.vala"
	_tmp2_ = self->priv->_wm;
#line 117 "../src/Widgets/WindowSwitcher.vala"
	_tmp3_ = meta_plugin_get_screen ((MetaPlugin*) _tmp2_);
#line 117 "../src/Widgets/WindowSwitcher.vala"
	g_signal_parse_name ("monitors-changed", meta_screen_get_type (), &_tmp4_, NULL, FALSE);
#line 117 "../src/Widgets/WindowSwitcher.vala"
	g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _gala_window_switcher_update_actors_meta_screen_monitors_changed, self);
#line 29 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_wm);
#line 31 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->current_window);
#line 33 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->window_clones);
#line 34 "../src/Widgets/WindowSwitcher.vala"
	(self->priv->clone_sort_order == NULL) ? NULL : (self->priv->clone_sort_order = (g_list_free (self->priv->clone_sort_order), NULL));
#line 36 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock_window);
#line 37 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock);
#line 38 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock_surface);
#line 39 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock_theme);
#line 40 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock_settings);
#line 44 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->monitor);
#line 46 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->background);
#line 51 "../src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 23 "../src/Widgets/WindowSwitcher.vala"
	G_OBJECT_CLASS (gala_window_switcher_parent_class)->finalize (obj);
#line 3958 "WindowSwitcher.c"
}

GType
gala_window_switcher_get_type (void)
{
	static volatile gsize gala_window_switcher_type_id__volatile = 0;
	if (g_once_init_enter (&gala_window_switcher_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaWindowSwitcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_switcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowSwitcher), 0, (GInstanceInitFunc) gala_window_switcher_instance_init, NULL };
		GType gala_window_switcher_type_id;
		gala_window_switcher_type_id = g_type_register_static (clutter_actor_get_type (), "GalaWindowSwitcher", &g_define_type_info, 0);
		GalaWindowSwitcher_private_offset = g_type_add_instance_private (gala_window_switcher_type_id, sizeof (GalaWindowSwitcherPrivate));
		g_once_init_leave (&gala_window_switcher_type_id__volatile, gala_window_switcher_type_id);
	}
	return gala_window_switcher_type_id__volatile;
}

static void
_vala_gala_window_switcher_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 23 "../src/Widgets/WindowSwitcher.vala"
	switch (property_id) {
#line 23 "../src/Widgets/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_WM_PROPERTY:
#line 23 "../src/Widgets/WindowSwitcher.vala"
		g_value_set_object (value, gala_window_switcher_get_wm (self));
#line 23 "../src/Widgets/WindowSwitcher.vala"
		break;
#line 3991 "WindowSwitcher.c"
		default:
#line 23 "../src/Widgets/WindowSwitcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Widgets/WindowSwitcher.vala"
		break;
#line 3997 "WindowSwitcher.c"
	}
}

static void
_vala_gala_window_switcher_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 23 "../src/Widgets/WindowSwitcher.vala"
	switch (property_id) {
#line 23 "../src/Widgets/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_WM_PROPERTY:
#line 23 "../src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_set_wm (self, g_value_get_object (value));
#line 23 "../src/Widgets/WindowSwitcher.vala"
		break;
#line 4017 "WindowSwitcher.c"
		default:
#line 23 "../src/Widgets/WindowSwitcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Widgets/WindowSwitcher.vala"
		break;
#line 4023 "WindowSwitcher.c"
	}
}

